var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);

// src/impl.ts
var impl_exports = {};
__export(impl_exports, {
  Calendar: () => Calendar,
  Duration: () => Duration,
  ExtendedDateTimeFormat: () => ExtendedDateTimeFormat,
  Instant: () => Instant,
  Now: () => Now,
  PlainDate: () => PlainDate,
  PlainDateTime: () => PlainDateTime,
  PlainMonthDay: () => PlainMonthDay,
  PlainTime: () => PlainTime,
  PlainYearMonth: () => PlainYearMonth,
  TimeZone: () => TimeZone,
  ZonedDateTime: () => ZonedDateTime2,
  dateToTemporalInstant: () => dateToTemporalInstant
});

// src/dateUtils/units.ts
var NANOSECOND = 0;
var MICROSECOND = 1;
var MILLISECOND = 2;
var SECOND = 3;
var MINUTE = 4;
var HOUR = 5;
var DAY = 6;
var WEEK = 7;
var MONTH = 8;
var YEAR = 9;
var nanoInMicroBI = 1000n;
var nanoInMilliBI = 1000000n;
var nanoInSecondBI = 1000000000n;
var nanoInMinuteBI = 60000000000n;
var nanoInHourBI = 3600000000000n;
var nanoInDayBI = 86400000000000n;
var nanoInMicro = 1e3;
var nanoInMilli = 1e6;
var nanoInSecond = 1e9;
var nanoInMinute = 6e10;
var nanoInHour = 36e11;
var nanoInDay = 864e11;
var nanoIn = [
  1,
  nanoInMicro,
  nanoInMilli,
  nanoInSecond,
  nanoInMinute,
  nanoInHour,
  nanoInDay
];
var milliInDay = 864e5;
var milliInSecond = 1e3;
var secondsInDay = 24 * 60 * 60;
var unitDigitMap = [
  9,
  6,
  3
];
function isDayTimeUnit(unit) {
  return unit <= DAY;
}
function isDateUnit(unit) {
  return unit >= DAY;
}

// src/argParse/overflowHandling.ts
var OVERFLOW_CONSTRAIN = 0;
var OVERFLOW_REJECT = 1;
var overflowHandlingMap = {
  constrain: 0,
  reject: 1
};
var parseOverflowOption = createOptionParser("overflow", overflowHandlingMap, OVERFLOW_CONSTRAIN);

// src/argParse/refine.ts
function createOptionParser(propName, map, defaultVal) {
  const valueParser = createParser(propName, map, defaultVal);
  return (options, runtimeDefaultVal) => {
    const ensured = ensureOptionsObj(options);
    return valueParser(ensured[propName], runtimeDefaultVal);
  };
}
function createParser(nameForError, map, defaultVal) {
  return (input, runtimeDefaultVal) => {
    if (input === void 0) {
      const d = runtimeDefaultVal ?? defaultVal;
      if (d === void 0) {
        throw new RangeError(`Must specify a ${nameForError}`);
      }
      return d;
    }
    if (map[input] === void 0) {
      throw new RangeError(`Invalid ${nameForError}: ${input}`);
    }
    return map[input];
  };
}
function constrainInt(val, min, max, overflowHandling) {
  if (val === void 0) {
    return min;
  }
  if (!Number.isFinite(val)) {
    throw new RangeError("Number must be finite");
  }
  val = Math.trunc(val);
  const newVal = Math.min(Math.max(val, min), max);
  if (newVal !== val && overflowHandling === OVERFLOW_REJECT) {
    throw new RangeError("Invalid overflowed value " + val);
  }
  return newVal;
}
function refineFields(input, refinerMap) {
  const res = {};
  for (const fieldName in refinerMap) {
    if (input[fieldName] !== void 0) {
      res[fieldName] = refinerMap[fieldName](input[fieldName]);
    }
  }
  return res;
}
function ensureOptionsObj(options) {
  if (options === void 0) {
    return {};
  }
  if (!isObjectLike(options)) {
    throw TypeError("options must be an object or undefined");
  }
  return options;
}
var objectLikeTypeRE = /object|function/;
function isObjectLike(v) {
  return v !== null && objectLikeTypeRE.test(typeof v);
}

// src/argParse/roundingMode.ts
var roundingModeMap = {
  halfExpand: Math.round,
  ceil: Math.ceil,
  trunc: Math.trunc,
  floor: Math.floor
};
var parseRoundingModeOption = createOptionParser("roundingMode", roundingModeMap);

// src/utils/obj.ts
function createWeakMap() {
  const map = /* @__PURE__ */ new WeakMap();
  return [
    map.get.bind(map),
    map.set.bind(map)
  ];
}
function attachGetters(ObjClass, getters) {
  Object.defineProperties(ObjClass.prototype, mapHash(getters, (func) => ({ get: func })));
}
function mapHash(hash, func) {
  const res = {};
  for (const key in hash) {
    res[key] = func(hash[key], key);
  }
  return res;
}
function mapHashByKeys(input, keys, func) {
  const output = {};
  for (const key of keys) {
    output[key] = func(input[key]);
  }
  return output;
}
function excludeUndefined(obj) {
  const res = {};
  for (const key in obj) {
    if (obj[key] !== void 0) {
      res[key] = obj[key];
    }
  }
  return res;
}
function strArrayToHash(strs, func) {
  const res = {};
  strs.forEach((str, i) => {
    res[str] = func(str, i);
  });
  return res;
}

// src/argParse/unitStr.ts
var timeUnitNames = [
  "nanosecond",
  "microsecond",
  "millisecond",
  "second",
  "minute",
  "hour"
];
var dateUnitNames = [
  "day",
  "week",
  "month",
  "year"
];
var unitNames = [
  ...timeUnitNames,
  ...dateUnitNames
];
var durationUnitNames = unitNames.map((unit) => unit + "s");
var unitMap = strArrayToHash(unitNames, (_str, i) => i);
var pluralUnitMap = strArrayToHash(durationUnitNames, (_str, i) => i);
function parseUnit(input, defaultUnit, minUnit, maxUnit) {
  let num;
  if (input === void 0) {
    if (defaultUnit === void 0) {
      throw new RangeError("Unit is required");
    }
    num = defaultUnit;
  } else {
    num = unitMap[input] ?? pluralUnitMap[input];
    if (num === void 0 || num < minUnit || num > maxUnit) {
      throw new RangeError("Invalid unit " + input);
    }
  }
  return num;
}

// src/argParse/diffOptions.ts
function parseDiffOptions(options, largestUnitDefault, smallestUnitDefault, minUnit, maxUnit, forDurationRounding) {
  const ensuredOptions = ensureOptionsObj(options);
  const roundingIncrement = ensuredOptions.roundingIncrement ?? 1;
  const smallestUnit = parseUnit(ensuredOptions.smallestUnit, smallestUnitDefault, minUnit, maxUnit);
  const roundingFunc = parseRoundingModeOption(ensuredOptions, forDurationRounding ? Math.round : Math.trunc);
  let largestUnitArg = ensuredOptions.largestUnit;
  if (largestUnitArg === "auto") {
    largestUnitArg = void 0;
  }
  largestUnitDefault = Math.max(largestUnitDefault, smallestUnit);
  const largestUnit = parseUnit(largestUnitArg, largestUnitDefault, minUnit, maxUnit);
  if (smallestUnit > largestUnit) {
    throw new RangeError("Bad smallestUnit/largestUnit");
  }
  if (smallestUnit < DAY) {
    const largerNano = nanoIn[smallestUnit + 1];
    const incNano = nanoIn[smallestUnit] * roundingIncrement;
    if (largerNano === incNano) {
      throw new RangeError("Must not equal larger unit");
    }
    if (largerNano % incNano) {
      throw new RangeError("Must divide into larger unit");
    }
  }
  return {
    smallestUnit,
    largestUnit,
    roundingFunc,
    roundingIncrement
  };
}

// src/argParse/roundingOptions.ts
function parseRoundingOptions(options, smallestUnitDefault, minUnit, maxUnit, relaxedDivisibility) {
  const optionsObj = typeof options === "string" ? { smallestUnit: options } : options;
  if (smallestUnitDefault === void 0 && !isObjectLike(optionsObj)) {
    throw new TypeError("Need rounding options");
  }
  const ensuredOptions = ensureOptionsObj(optionsObj);
  const roundingIncrement = ensuredOptions.roundingIncrement ?? 1;
  const smallestUnit = parseUnit(ensuredOptions.smallestUnit, smallestUnitDefault, minUnit, maxUnit);
  const roundingFunc = parseRoundingModeOption(ensuredOptions, Math.round);
  const incNano = nanoIn[smallestUnit] * roundingIncrement;
  if (smallestUnit === DAY) {
    if (roundingIncrement !== 1) {
      throw new RangeError("When smallestUnit is days, roundingIncrement must be 1");
    }
  } else {
    const largerNano = relaxedDivisibility ? nanoInDay : nanoIn[smallestUnit + 1];
    if (!relaxedDivisibility && largerNano === incNano) {
      throw new RangeError("Must not equal larger unit");
    }
    if (largerNano % incNano) {
      throw new RangeError("Must divide into larger unit");
    }
  }
  return {
    smallestUnit,
    roundingFunc,
    incNano
  };
}

// src/dateUtils/abstract.ts
var formatFactoryFactorySymbol = Symbol();
function ensureObj(ObjClass, arg, ...otherArgs) {
  if (arg instanceof ObjClass) {
    return arg;
  }
  return ObjClass.from(arg, ...otherArgs);
}
var AbstractObj = class {
  toJSON() {
    return this.toString();
  }
};
var AbstractNoValueObj = class extends AbstractObj {
  valueOf() {
    throw new Error("Cannot convert object using valueOf");
  }
};
var [getISOFields, setISOFields] = createWeakMap();
var AbstractISOObj = class extends AbstractNoValueObj {
  constructor(isoFields) {
    super();
    setISOFields(this, Object.freeze(isoFields));
  }
  getISOFields() {
    return getISOFields(this);
  }
};

// src/utils/math.ts
function compareValues(a, b) {
  if (a < b) {
    return -1;
  } else if (a > b) {
    return 1;
  }
  return 0;
}
function numSign(num) {
  return compareValues(num, 0);
}
function roundToIncrement(num, inc, roundingFunc) {
  return roundingFunc(num / inc) * inc;
}
function roundToMinute(nano) {
  return roundToIncrement(nano, nanoInMinute, halfExpand);
}
function halfExpand(n) {
  return Math.round(Math.abs(n)) * numSign(n);
}
function roundToIncrementBI(num, inc, roundingFunc) {
  const incBI = BigInt(inc);
  const wholeUnits = num / incBI;
  const wholeNum = wholeUnits * incBI;
  const leftover = Number(num - wholeNum);
  return wholeNum + BigInt(roundingFunc(leftover / inc)) * incBI;
}
function positiveModulo(n, max) {
  return (n % max + max) % max;
}

// src/dateUtils/durationFields.ts
var durationFieldNames = durationUnitNames.concat("sign");
function negateDuration(fields) {
  return mapHashByKeys(fields, durationFieldNames, (n) => -n || 0);
}
function absDuration(fields) {
  return mapHashByKeys(fields, durationFieldNames, (n) => Math.abs(n));
}
function mergeDurations(d0, d1) {
  return {
    sign: d0.sign || d1.sign,
    years: d0.years + d1.years,
    months: d0.months + d1.months,
    weeks: d0.weeks + d1.weeks,
    days: d0.days + d1.days,
    hours: d0.hours + d1.hours,
    minutes: d0.minutes + d1.minutes,
    seconds: d0.seconds + d1.seconds,
    milliseconds: d0.milliseconds + d1.milliseconds,
    microseconds: d0.microseconds + d1.microseconds,
    nanoseconds: d0.nanoseconds + d1.nanoseconds
  };
}
function overrideDuration(d0, d1) {
  return signDuration({
    years: d1.years ?? d0.years,
    months: d1.months ?? d0.months,
    weeks: d1.weeks ?? d0.weeks,
    days: d1.days ?? d0.days,
    hours: d1.hours ?? d0.hours,
    minutes: d1.minutes ?? d0.minutes,
    seconds: d1.seconds ?? d0.seconds,
    milliseconds: d1.milliseconds ?? d0.milliseconds,
    microseconds: d1.microseconds ?? d0.microseconds,
    nanoseconds: d1.nanoseconds ?? d0.nanoseconds
  });
}
function refineDurationNumbers(unsignedFields) {
  const fields = signDuration(unsignedFields);
  const { sign } = fields;
  for (const fieldName of durationUnitNames) {
    const fieldNum = fields[fieldName];
    const fieldSign = numSign(fields[fieldName]);
    if (fieldSign && fieldSign !== sign) {
      throw new RangeError("All fields must be same sign");
    }
    if (!Number.isInteger(fieldNum)) {
      throw new RangeError("Duration fields must be integers");
    }
  }
  return fields;
}
function signDuration(fields) {
  return { ...fields, sign: computeDurationSign(fields) };
}
function computeDurationSign(fields) {
  let sign = 0;
  for (const fieldName of durationUnitNames) {
    const fieldNum = fields[fieldName];
    if (fieldNum) {
      sign = numSign(fields[fieldName]);
      break;
    }
  }
  return sign;
}
function computeLargestDurationUnit(dur) {
  let unit = YEAR;
  while (unit > NANOSECOND && !dur[durationUnitNames[unit]]) {
    unit--;
  }
  return unit;
}

// src/dateUtils/dayAndTime.ts
var zeroISOTimeFields = {
  isoHour: 0,
  isoMinute: 0,
  isoSecond: 0,
  isoMillisecond: 0,
  isoMicrosecond: 0,
  isoNanosecond: 0
};
var zeroDurationTimeFields = {
  hours: 0,
  minutes: 0,
  seconds: 0,
  milliseconds: 0,
  microseconds: 0,
  nanoseconds: 0
};
function partialLocalTimeToISO(fields) {
  return {
    isoHour: fields.hour || 0,
    isoMinute: fields.minute || 0,
    isoSecond: fields.second || 0,
    isoMillisecond: fields.millisecond || 0,
    isoMicrosecond: fields.microsecond || 0,
    isoNanosecond: fields.nanosecond || 0
  };
}
function durationDayTimeToNano(fields) {
  return BigInt(fields.days) * nanoInDayBI + durationTimeToNano(fields);
}
function durationTimeToNano(fields) {
  return BigInt(fields.hours) * nanoInHourBI + BigInt(fields.minutes) * nanoInMinuteBI + BigInt(fields.seconds) * nanoInSecondBI + BigInt(fields.milliseconds) * nanoInMilliBI + BigInt(fields.microseconds) * nanoInMicroBI + BigInt(fields.nanoseconds);
}
function isoTimeToNano(fields) {
  return fields.isoHour * nanoInHour + fields.isoMinute * nanoInMinute + fields.isoSecond * nanoInSecond + fields.isoMillisecond * nanoInMilli + fields.isoMicrosecond * nanoInMicro + fields.isoNanosecond;
}
function nanoToDuration(nano, largestUnit) {
  let days = 0;
  let hours = 0;
  let minutes = 0;
  let seconds = 0;
  let milliseconds = 0;
  let microseconds = 0;
  let temp;
  switch (largestUnit) {
    case DAY:
      temp = nano / nanoInDayBI;
      days = Number(temp);
      nano -= temp * nanoInDayBI;
    case HOUR:
      temp = nano / nanoInHourBI;
      hours = Number(temp);
      nano -= temp * nanoInHourBI;
    case MINUTE:
      temp = nano / nanoInMinuteBI;
      minutes = Number(temp);
      nano -= temp * nanoInMinuteBI;
    case SECOND:
      temp = nano / nanoInSecondBI;
      seconds = Number(temp);
      nano -= temp * nanoInSecondBI;
    case MILLISECOND:
      temp = nano / nanoInMilliBI;
      milliseconds = Number(temp);
      nano -= temp * nanoInMilliBI;
    case MICROSECOND:
      temp = nano / nanoInMicroBI;
      microseconds = Number(temp);
      nano -= temp * nanoInMicroBI;
  }
  return signDuration({
    years: 0,
    months: 0,
    weeks: 0,
    days,
    hours,
    minutes,
    seconds,
    milliseconds,
    microseconds,
    nanoseconds: Number(nano)
  });
}
function nanoToISOTime(timeNano) {
  const dayDelta = Math.floor(timeNano / nanoInDay);
  timeNano -= dayDelta * nanoInDay;
  const isoHour = Math.floor(timeNano / nanoInHour);
  timeNano -= isoHour * nanoInHour;
  const isoMinute = Math.floor(timeNano / nanoInMinute);
  timeNano -= isoMinute * nanoInMinute;
  const isoSecond = Math.floor(timeNano / nanoInSecond);
  timeNano -= isoSecond * nanoInSecond;
  const isoMillisecond = Math.floor(timeNano / nanoInMilli);
  timeNano -= isoMillisecond * nanoInMilli;
  const isoMicrosecond = Math.floor(timeNano / nanoInMicro);
  timeNano -= isoMicrosecond * nanoInMicro;
  const isoTimeFields = {
    isoHour,
    isoMinute,
    isoSecond,
    isoMillisecond,
    isoMicrosecond,
    isoNanosecond: timeNano
  };
  return [isoTimeFields, dayDelta];
}

// src/utils/string.ts
function capitalizeFirstLetter(s) {
  return s.charAt(0).toUpperCase() + s.slice(1);
}
function padZeros(num, length) {
  return String(num).padStart(length, "0");
}
function getSignStr(num) {
  return num < 0 ? "-" : "+";
}

// src/calendarImpl/eraOrigins.ts
var eraOrigins = {
  gregory: {
    bce: -1,
    ce: 0
  },
  ethioaa: {
    era0: 0
  },
  ethiopic: {
    era0: 0,
    era1: 5500
  },
  coptic: {
    era0: -1,
    era1: 0
  },
  roc: {
    beforeroc: -1,
    minguo: 0
  },
  buddhist: {
    be: 0
  },
  islamic: {
    ah: 0
  },
  indian: {
    saka: 0
  },
  persian: {
    ap: 0
  },
  japanese: {
    bce: -1,
    ce: 0,
    meiji: 1867,
    taisho: 1911,
    showa: 1925,
    heisei: 1988,
    reiwa: 2018
  }
};

// src/calendarImpl/calendarImpl.ts
var CalendarImpl = class {
  constructor(id) {
    this.id = id;
  }
  monthCode(month, _year) {
    return "M" + padZeros(month, 2);
  }
  convertMonthCode(monthCode, _year) {
    const monthCodeIsLeap = /L$/.test(monthCode);
    const monthCodeInt = parseInt(monthCode.substr(1));
    if (monthCodeIsLeap) {
      throw new RangeError("Calendar system doesnt support leap months");
    }
    return [monthCodeInt, false];
  }
};
function convertEraYear(calendarID, eraYear, era, fromDateTimeFormat) {
  let origin = eraOrigins[getCalendarIDBase(calendarID)]?.[era];
  if (origin === void 0) {
    if (fromDateTimeFormat) {
      origin = 0;
    } else {
      throw new Error("Unkown era " + era);
    }
  }
  return (origin + eraYear) * (numSign(origin) || 1);
}
function hasEras(calendarID) {
  return eraOrigins[getCalendarIDBase(calendarID)] !== void 0;
}
function getCalendarIDBase(calendarID) {
  return calendarID.split("-")[0];
}

// src/calendarImpl/isoCalendarImpl.ts
var ISOCalendarImpl = class extends CalendarImpl {
  computeFields(epochMilli) {
    const fields = epochMilliToISOFields(epochMilli);
    return {
      era: void 0,
      eraYear: void 0,
      year: fields.isoYear,
      month: fields.isoMonth,
      day: fields.isoDay
    };
  }
  epochMilliseconds(year, month, day) {
    return isoToEpochMilli(year, month, day);
  }
  daysInMonth(year, month) {
    if (month === 2) {
      return this.inLeapYear(year) ? 29 : 28;
    }
    if (month === 4 || month === 6 || month === 9 || month === 11) {
      return 30;
    }
    return 31;
  }
  monthsInYear() {
    return 12;
  }
  inLeapYear(year) {
    return year % 4 === 0 && (year % 100 !== 0 || year % 400 === 0);
  }
  guessYearForMonthDay() {
    return isoEpochLeapYear;
  }
  normalizeISOYearForMonthDay() {
    return isoEpochLeapYear;
  }
};
var isoCalendarID = "iso8601";
var isoCalendarImpl = new ISOCalendarImpl(isoCalendarID);

// src/dateUtils/epoch.ts
var isoEpochOriginYear = 1970;
var isoEpochLeapYear = 1972;
function isoFieldsToEpochNano(isoFields) {
  return isoToEpochNano(isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay, isoFields.isoHour, isoFields.isoMinute, isoFields.isoSecond, isoFields.isoMillisecond, isoFields.isoMicrosecond, isoFields.isoNanosecond);
}
function isoFieldsToEpochMilli(isoFields) {
  return isoToEpochMilli(isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay, isoFields.isoHour, isoFields.isoMinute, isoFields.isoSecond, isoFields.isoMillisecond);
}
function isoToEpochNano(isoYear, isoMonth, isoDay, isoHour, isoMinute, isoSecond, isoMillisecond, isoMicrosecond, isoNanosecond) {
  return BigInt(isoToEpochMilli(isoYear, isoMonth, isoDay, isoHour, isoMinute, isoSecond, isoMillisecond)) * nanoInMilliBI + BigInt(isoMicrosecond ?? 0) * nanoInMicroBI + BigInt(isoNanosecond ?? 0);
}
function isoToEpochMilli(isoYear, isoMonth, isoDay, isoHour, isoMinute, isoSecond, isoMillisecond) {
  const sign = numSign(isoYear);
  let dayShiftAbs = 0;
  let isoDayTry;
  let milli;
  const twoDigitYearBug = isoYear >= 0 && isoYear < 1e3;
  const isoYearTemp = twoDigitYearBug ? isoYear + 1200 : isoYear;
  for (; dayShiftAbs < 31; dayShiftAbs++) {
    isoDayTry = isoDay - sign * dayShiftAbs;
    const milliTry = Date.UTC(isoYearTemp, isoMonth - 1, isoDayTry, isoHour ?? 0, isoMinute ?? 0, isoSecond ?? 0, isoMillisecond ?? 0);
    if (!isInvalid(milliTry)) {
      milli = milliTry + sign * dayShiftAbs * milliInDay;
      break;
    }
  }
  if (milli === void 0 || isoDayTry < 1 || isoDayTry > isoCalendarImpl.daysInMonth(isoYear, isoMonth)) {
    throwOutOfRange();
  }
  if (twoDigitYearBug) {
    milli = new Date(milli).setUTCFullYear(isoYear);
  }
  return milli;
}
function epochNanoToISOFields(epochNano) {
  let epochMilli = epochNano / nanoInMilliBI;
  let leftoverNano = Number(epochNano - epochMilli * nanoInMilliBI);
  if (leftoverNano < 0) {
    leftoverNano += nanoInMilli;
    epochMilli -= 1n;
  }
  const isoMicrosecond = Math.floor(leftoverNano / nanoInMicro);
  leftoverNano -= isoMicrosecond * nanoInMicro;
  return {
    ...epochMilliToISOFields(Number(epochMilli)),
    isoMicrosecond,
    isoNanosecond: leftoverNano
  };
}
function epochMilliToISOFields(epochMilli) {
  const [legacy, dayUnshift] = nudgeToLegacyDate(epochMilli);
  return {
    isoYear: legacy.getUTCFullYear(),
    isoMonth: legacy.getUTCMonth() + 1,
    isoDay: legacy.getUTCDate() + dayUnshift,
    isoHour: legacy.getUTCHours(),
    isoMinute: legacy.getUTCMinutes(),
    isoSecond: legacy.getUTCSeconds(),
    isoMillisecond: legacy.getUTCMilliseconds()
  };
}
function toEpochNano(dt) {
  return dt.epochNanoseconds ?? isoFieldsToEpochNano(dt.getISOFields());
}
function isoYearToEpochSeconds(isoYear) {
  return Math.floor(isoToEpochMilli(isoYear, 1, 1) / milliInSecond);
}
function epochNanoToISOYear(epochNano) {
  return nudgeToLegacyDate(Number(epochNano / nanoInMilliBI))[0].getUTCFullYear();
}
function computeISODayOfWeek(isoYear, isoMonth, isoDay) {
  const [legacy, dayUnshift] = nudgeToLegacyDate(isoToEpochMilli(isoYear, isoMonth, isoDay));
  return positiveModulo(legacy.getUTCDay() + dayUnshift, 7) || 7;
}
function nudgeToLegacyDate(epochMilli) {
  const sign = numSign(epochMilli);
  let dayShiftAbs = 0;
  let date;
  for (; dayShiftAbs < 31; dayShiftAbs++) {
    const dateTry = new Date(epochMilli - sign * dayShiftAbs * milliInDay);
    if (!isInvalid(dateTry)) {
      date = dateTry;
      break;
    }
  }
  if (date === void 0) {
    throwOutOfRange();
  }
  return [date, sign * dayShiftAbs];
}
function isInvalid(n) {
  return isNaN(n.valueOf());
}
function throwOutOfRange() {
  throw new RangeError("Date outside of supported range");
}
function diffDaysMilli(epochMilli0, epochMilli1) {
  return Math.round((epochMilli1 - epochMilli0) / milliInDay);
}
function addDaysMilli(epochMilli, days) {
  return epochMilli + days * milliInDay;
}
function splitEpochNano(epochNano) {
  const isoFields = epochNanoToISOFields(epochNano);
  const dayEpochNano = isoToEpochNano(isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay);
  const timeNano = isoTimeToNano(isoFields);
  return [dayEpochNano, timeNano];
}

// src/dateUtils/compare.ts
function zonedDateTimesEqual(a, b) {
  return dateTimesEqual(a, b) && a.timeZone.id === b.timeZone.id;
}
function dateTimesEqual(a, b) {
  return !compareDateTimes(a, b) && a.calendar.id === b.calendar.id;
}
function compareDateTimes(a, b) {
  return compareValues(isoFieldsToEpochNano(a.getISOFields()), isoFieldsToEpochNano(b.getISOFields()));
}
function compareTimes(t0, t1) {
  return compareValues(isoTimeToNano(t0.getISOFields()), isoTimeToNano(t1.getISOFields()));
}
function compareLocalDateFields(d0, d1) {
  return compareValues(d0.year, d1.year) || compareValues(d0.month, d1.month) || compareValues(d0.day, d1.day);
}
function compareEpochObjs(a, b) {
  return compareValues(a.epochNanoseconds, b.epochNanoseconds);
}
function compareDurations(fields0, fields1, relativeTo) {
  if (relativeTo === void 0 && computeLargestDurationUnit(fields0) <= DAY && computeLargestDurationUnit(fields1) <= DAY) {
    return compareValues(durationDayTimeToNano(fields0), durationDayTimeToNano(fields1));
  }
  if (!relativeTo) {
    throw new RangeError("Need relativeTo");
  }
  const date0 = relativeTo.add(fields0);
  const date1 = relativeTo.add(fields1);
  if (relativeTo.epochNanoseconds !== void 0) {
    return compareEpochObjs(date0, date1);
  }
  return compareDateTimes(date0, date1);
}

// src/dateUtils/constrain.ts
function constrainDateFields(year, month, day, calendarImpl, overflow) {
  year = Number(year);
  month = constrainInt(month, 1, calendarImpl.monthsInYear(year), overflow);
  day = constrainInt(day, 1, calendarImpl.daysInMonth(year, month), overflow);
  return [year, month, day];
}
function constrainDateISO(isoFields, overflow) {
  const [isoYear, isoMonth, isoDay] = constrainDateFields(isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay, isoCalendarImpl, overflow);
  return { isoYear, isoMonth, isoDay };
}
function isValidDateISO(isoFields) {
  try {
    constrainDateISO(isoFields, OVERFLOW_REJECT);
    return true;
  } catch (ex) {
    return false;
  }
}
function constrainDateTimeISO(isoFields, overflow) {
  return {
    ...constrainDateISO(isoFields, overflow),
    ...constrainTimeISO(isoFields, overflow)
  };
}
function constrainTimeISO({
  isoHour,
  isoMinute,
  isoSecond,
  isoMillisecond,
  isoMicrosecond,
  isoNanosecond
}, overflow) {
  isoHour = constrainInt(isoHour, 0, 23, overflow);
  isoMinute = constrainInt(isoMinute, 0, 59, overflow);
  isoSecond = constrainInt(isoSecond, 0, 59, overflow);
  isoMillisecond = constrainInt(isoMillisecond, 0, 999, overflow);
  isoMicrosecond = constrainInt(isoMicrosecond, 0, 999, overflow);
  isoNanosecond = constrainInt(isoNanosecond, 0, 999, overflow);
  return { isoHour, isoMinute, isoSecond, isoMillisecond, isoMicrosecond, isoNanosecond };
}

// src/argParse/fieldStr.ts
var yearMonthFieldMap = {
  era: String,
  eraYear: Number,
  year: Number,
  month: Number,
  monthCode: String
};
var dateFieldMap = {
  ...yearMonthFieldMap,
  day: Number
};
var timeFieldMap = {
  hour: Number,
  minute: Number,
  second: Number,
  millisecond: Number,
  microsecond: Number,
  nanosecond: Number
};
var monthDayFieldMap = {
  era: String,
  eraYear: Number,
  year: Number,
  month: Number,
  monthCode: String,
  day: Number
};
var durationFieldMap = strArrayToHash(durationUnitNames, () => Number);

// src/calendarImpl/gregoryCalendarImpl.ts
var GregoryCalendarImpl = class extends ISOCalendarImpl {
  computeFields(epochMilli) {
    const fields = super.computeFields(epochMilli);
    const { year } = fields;
    return {
      ...fields,
      era: year < 1 ? "bce" : "ce",
      eraYear: year < 1 ? -(year - 1) : year
    };
  }
};

// src/argParse/calendarDisplay.ts
var CALENDAR_DISPLAY_AUTO = 0;
var CALENDAR_DISPLAY_NEVER = 1;
var CALENDAR_DISPLAY_ALWAYS = 2;
var calendarDisplayMap = {
  auto: 0,
  never: 1,
  always: 2
};
var parseCalendarDisplayOption = createOptionParser("calendarName", calendarDisplayMap, CALENDAR_DISPLAY_AUTO);

// src/argParse/isoFormatOptions.ts
function parseTimeToStringOptions(options, largestUnit = MINUTE) {
  const ensuredOptions = ensureOptionsObj(options);
  const smallestUnitArg = ensuredOptions.smallestUnit;
  const digitsArg = ensuredOptions.fractionalSecondDigits;
  let smallestUnit = NANOSECOND;
  let incNano = 1;
  let digits;
  if (smallestUnitArg !== void 0) {
    smallestUnit = parseUnit(smallestUnitArg, void 0, NANOSECOND, largestUnit);
    incNano = nanoIn[smallestUnit];
    digits = unitDigitMap[smallestUnit] || 0;
  } else if (digitsArg !== void 0 && digitsArg !== "auto") {
    digits = constrainInt(digitsArg, 0, 9, OVERFLOW_REJECT);
    incNano = Math.pow(10, 9 - digits);
  }
  return {
    smallestUnit,
    fractionalSecondDigits: digits,
    roundingFunc: parseRoundingModeOption(options, Math.trunc),
    incNano
  };
}

// src/argParse/disambig.ts
var DISAMBIG_COMPATIBLE = 0;
var DISAMBIG_EARLIER = 1;
var DISAMBIG_REJECT = 3;
var disambigMap = {
  compatible: 0,
  earlier: 1,
  later: 2,
  reject: 3
};
var parseDisambigOption = createOptionParser("disambiguation", disambigMap, DISAMBIG_COMPATIBLE);

// src/argParse/timeZoneDisplay.ts
var TIME_ZONE_DISPLAY_AUTO = 0;
var TIME_ZONE_DISPLAY_NEVER = 1;
var timeZoneDisplayMap = {
  auto: 0,
  never: 1
};
var parseTimeZoneDisplayOption = createOptionParser("timeZoneName", timeZoneDisplayMap, TIME_ZONE_DISPLAY_AUTO);

// src/dateUtils/isoFormat.ts
function formatDateTimeISO(fields, formatConfig) {
  return formatDateISO(fields) + "T" + formatTimeISO(fields, formatConfig);
}
function formatDateISO(fields) {
  return formatYearMonthISO(fields) + "-" + padZeros(fields.isoDay, 2);
}
function formatYearMonthISO(fields) {
  const { isoYear } = fields;
  return (isoYear < 1e3 || isoYear > 9999 ? getSignStr(isoYear) + padZeros(Math.abs(isoYear), 6) : padZeros(isoYear, 4)) + "-" + padZeros(fields.isoMonth, 2);
}
function formatMonthDayISO(fields) {
  return padZeros(fields.isoMonth, 2) + "-" + padZeros(fields.isoDay, 2);
}
function formatTimeISO(fields, formatConfig) {
  const parts = [padZeros(fields.isoHour, 2)];
  if (formatConfig.smallestUnit <= MINUTE) {
    parts.push(padZeros(fields.isoMinute, 2));
    if (formatConfig.smallestUnit <= SECOND) {
      parts.push(padZeros(fields.isoSecond, 2) + formatPartialSeconds(fields.isoMillisecond, fields.isoMicrosecond, fields.isoNanosecond, formatConfig.fractionalSecondDigits)[0]);
    }
  }
  return parts.join(":");
}
function formatOffsetISO(offsetNano) {
  const [fields, dayDelta] = nanoToISOTime(Math.abs(offsetNano));
  const partialSecondsStr = formatPartialSeconds(fields.isoMillisecond, fields.isoMicrosecond, fields.isoNanosecond, void 0)[0];
  return getSignStr(offsetNano) + padZeros(fields.isoHour + dayDelta * 24, 2) + ":" + padZeros(fields.isoMinute, 2) + (fields.isoSecond || partialSecondsStr ? ":" + padZeros(fields.isoSecond, 2) + partialSecondsStr : "");
}
function formatCalendarID(calendarID, display) {
  if (calendarID && (display === CALENDAR_DISPLAY_ALWAYS || display !== CALENDAR_DISPLAY_NEVER && calendarID !== isoCalendarID)) {
    return `[u-ca=${calendarID}]`;
  }
  return "";
}
function formatTimeZoneID(timeZoneID, display) {
  if (display !== TIME_ZONE_DISPLAY_NEVER) {
    return `[${timeZoneID}]`;
  }
  return "";
}
function formatDurationISO(fields, formatConfig) {
  const { smallestUnit, fractionalSecondDigits, roundingFunc } = formatConfig;
  const { sign } = fields;
  const hours = BigInt(fields.hours);
  const minutes = BigInt(fields.minutes);
  let seconds = BigInt(fields.seconds);
  let partialSecondsStr = "";
  if (smallestUnit <= SECOND) {
    const res = formatPartialSeconds(fields.milliseconds, fields.microseconds, fields.nanoseconds, fractionalSecondDigits, roundingFunc, smallestUnit);
    partialSecondsStr = res[0];
    seconds += BigInt(res[1]);
  }
  const forceSeconds = fractionalSecondDigits !== void 0 || partialSecondsStr || !sign;
  return (sign < 0 ? "-" : "") + "P" + collapseDurationTuples([
    [BigInt(fields.years), "Y"],
    [BigInt(fields.months), "M"],
    [BigInt(fields.weeks), "W"],
    [BigInt(fields.days), "D"]
  ]) + (hours || minutes || seconds || forceSeconds ? "T" + collapseDurationTuples([
    [hours, "H"],
    [minutes, "M"],
    [
      smallestUnit <= SECOND ? seconds : BigInt(0),
      partialSecondsStr + "S",
      forceSeconds
    ]
  ]) : "");
}
function collapseDurationTuples(tuples) {
  return tuples.map(([num, postfix, forceShow]) => {
    if (forceShow || num) {
      return (num < BigInt(0) ? -num : num) + postfix;
    }
    return "";
  }).join("");
}
function formatPartialSeconds(milliseconds, microseconds, nanoseconds, fractionalSecondDigits, roundingFunc, smallestUnit) {
  let totalNano = BigInt(nanoseconds) + BigInt(microseconds) * nanoInMicroBI + BigInt(milliseconds) * nanoInMilliBI;
  if (roundingFunc) {
    totalNano = roundToIncrementBI(totalNano, fractionalSecondDigits === void 0 ? nanoIn[smallestUnit] : Math.pow(10, 9 - fractionalSecondDigits), roundingFunc);
  }
  const totalNanoAbs = totalNano < 0 ? -totalNano : totalNano;
  const seconds = totalNanoAbs / nanoInSecondBI;
  const leftoverNano = totalNanoAbs - seconds * nanoInSecondBI;
  let afterDecimal = padZeros(Number(leftoverNano), 9);
  afterDecimal = fractionalSecondDigits === void 0 ? afterDecimal.replace(/0+$/, "") : afterDecimal.substr(0, fractionalSecondDigits);
  return [
    afterDecimal ? "." + afterDecimal : "",
    Number(seconds) * (totalNano < 0 ? -1 : 1)
  ];
}

// src/dateUtils/mixins.ts
function mixinEpochFields(ObjClass) {
  attachGetters(ObjClass, {
    epochMicroseconds() {
      return this.epochNanoseconds / nanoInMicroBI;
    },
    epochMilliseconds() {
      return Number(this.epochNanoseconds / nanoInMilliBI);
    },
    epochSeconds() {
      return Number(this.epochNanoseconds / nanoInSecondBI);
    }
  });
}
var isoFieldMap = {
  calendar: "calendar"
};
for (const unitName of unitNames) {
  isoFieldMap[unitName] = "iso" + capitalizeFirstLetter(unitName);
}
function mixinISOFields(ObjClass, unitNames2 = []) {
  attachGetters(ObjClass, strArrayToHash(unitNames2.concat("calendar"), (propName) => function() {
    return this.getISOFields()[isoFieldMap[propName]];
  }));
}
var yearMonthCalendarFields = [
  "era",
  "eraYear",
  "year",
  "month",
  "monthCode",
  "daysInMonth",
  "daysInYear",
  "monthsInYear",
  "inLeapYear"
];
var monthDayCalendarFields = [
  "monthCode",
  "day"
];
var dateCalendarFields = [
  ...yearMonthCalendarFields,
  "day",
  "dayOfWeek",
  "dayOfYear",
  "weekOfYear",
  "daysInWeek"
];
function mixinCalendarFields(ObjClass, propNames) {
  attachGetters(ObjClass, strArrayToHash(propNames, (propName) => function() {
    const value = this.calendar[propName](this);
    Object.defineProperty(this, propName, { value });
    return value;
  }));
}
function attachStringTag(objOrClass, name) {
  (objOrClass.prototype || objOrClass)[Symbol.toStringTag] = "Temporal." + name;
}

// src/argParse/offsetHandling.ts
var OFFSET_PREFER = 0;
var OFFSET_USE = 1;
var OFFSET_IGNORE = 2;
var OFFSET_REJECT = 3;
var offsetHandlingMap = {
  prefer: 0,
  use: 1,
  ignore: 2,
  reject: 3
};
var parseOffsetHandlingOption = createOptionParser("offset", offsetHandlingMap);

// src/dateUtils/translate.ts
function translateZonedDateTimeFields(fields, duration, options) {
  const { calendar, timeZone } = fields;
  const translatedDate = calendar.dateAdd(createDate(fields), overrideDuration(duration, zeroDurationTimeFields), options);
  const translatedDateTime = createDateTime({
    ...fields,
    ...translatedDate.getISOFields()
  });
  const translatedInstant = timeZone.getInstantFor(translatedDateTime);
  return translatedInstant.epochNanoseconds + durationTimeToNano(duration);
}
function translateDateTime(fields, duration, options) {
  const { calendar } = fields;
  const date = calendar.dateAdd(createDate(fields), overrideDuration(duration, zeroDurationTimeFields), options);
  const epochNano = isoFieldsToEpochNano(date.getISOFields()) + BigInt(isoTimeToNano(fields)) + durationTimeToNano(duration);
  return epochNanoToISOFields(epochNano);
}
function translateDate(dateFields, durationFields, calendarImpl, overflowHandling) {
  dateFields = addYears(dateFields, durationFields.years, calendarImpl, overflowHandling);
  dateFields = addMonths(dateFields, durationFields.months, calendarImpl, overflowHandling);
  let epochMilli = calendarImpl.epochMilliseconds(dateFields.year, dateFields.month, dateFields.day);
  const daysFromTime = Math.trunc(Number(durationTimeToNano(durationFields)) / nanoInDay);
  const days = durationFields.weeks * 7 + durationFields.days + daysFromTime;
  epochMilli = addDaysMilli(epochMilli, days);
  return epochMilliToISOFields(epochMilli);
}
function addYears({ year, month, day }, yearsToAdd, calendarImpl, overflowHandling) {
  year += yearsToAdd;
  const newMonth = constrainInt(month, 1, calendarImpl.monthsInYear(year), overflowHandling);
  let newDay = month === newMonth ? day : 1;
  newDay = constrainInt(newDay, 1, calendarImpl.daysInMonth(year, newMonth), overflowHandling);
  return { year, month: newMonth, day: newDay };
}
function addMonths({ year, month, day }, monthsToAdd, calendarImpl, overflowHandling) {
  if (monthsToAdd) {
    month += monthsToAdd;
    if (monthsToAdd < 0) {
      while (month < 1) {
        month += calendarImpl.monthsInYear(--year);
      }
    } else {
      let monthsInYear;
      while (month > (monthsInYear = calendarImpl.monthsInYear(year))) {
        month -= monthsInYear;
        year++;
      }
    }
    day = constrainInt(day, 1, calendarImpl.daysInMonth(year, month), overflowHandling);
  }
  return { year, month, day };
}
function addDays({ isoYear, isoMonth, isoDay }, days) {
  if (days) {
    let epochMilli = isoToEpochMilli(isoYear, isoMonth, isoDay);
    epochMilli = addDaysMilli(epochMilli, days);
    ({ isoYear, isoMonth, isoDay } = epochMilliToISOFields(epochMilli));
  }
  return { isoYear, isoMonth, isoDay };
}
function translateTime(timeFields, durationFields) {
  const nano = isoTimeToNano(timeFields) + Number(durationTimeToNano(durationFields));
  const [newTimeFields] = nanoToISOTime(nano);
  return newTimeFields;
}
function translateEpochNano(epochNano, durationFields) {
  const largestUnit = computeLargestDurationUnit(durationFields);
  if (largestUnit >= DAY) {
    throw new RangeError("Duration cant have units >= days");
  }
  return epochNano + durationTimeToNano(durationFields);
}
function addDurationFields(d0, d1, relativeTo, calendar) {
  const largestUnit = Math.max(computeLargestDurationUnit(d0), computeLargestDurationUnit(d1));
  if (relativeTo === void 0 && largestUnit <= DAY) {
    return nanoToDuration(durationDayTimeToNano(d0) + durationDayTimeToNano(d1), largestUnit);
  }
  if (!relativeTo) {
    throw new RangeError("Need relativeTo");
  }
  const translated = relativeTo.add(d0).add(d1);
  return diffAccurate(relativeTo, translated, calendar, largestUnit);
}

// src/dateUtils/offset.ts
function checkInvalidOffset(isoFields) {
  const { offsetNanoseconds: offsetNano, timeZone, Z } = isoFields;
  if (offsetNano !== void 0 && !Z) {
    const matchingEpochNano = findMatchingEpochNano(isoFields, offsetNano, timeZone, true);
    if (matchingEpochNano === void 0) {
      throw new RangeError("Mismatching offset/timezone");
    }
  }
}
function computeZonedDateTimeEpochNano(isoFields, fuzzyMatching, offsetHandling = OFFSET_REJECT, disambigOptions) {
  const { offsetNanoseconds: offsetNano, timeZone, Z } = isoFields;
  if (offsetNano !== void 0 && offsetHandling !== OFFSET_IGNORE) {
    if (offsetHandling === OFFSET_USE || Z) {
      return isoFieldsToEpochNano(isoFields) - BigInt(offsetNano);
    } else {
      const matchingEpochNano = findMatchingEpochNano(isoFields, offsetNano, timeZone, fuzzyMatching);
      if (matchingEpochNano !== void 0) {
        return matchingEpochNano;
      }
      if (offsetHandling === OFFSET_REJECT) {
        throw new RangeError("Mismatching offset/timezone");
      }
    }
  }
  return timeZone.getInstantFor(createDateTime(isoFields), disambigOptions).epochNanoseconds;
}
function findMatchingEpochNano(isoFields, offsetNano, timeZone, fuzzyMatching) {
  const possibleInstants = timeZone.getPossibleInstantsFor(createDateTime(isoFields));
  const utcEpochNano = isoFieldsToEpochNano(isoFields);
  const roundedOffsetNano = fuzzyMatching ? roundToMinute(offsetNano) : offsetNano;
  for (const instant of possibleInstants) {
    const possibleEpochNano = instant.epochNanoseconds;
    const possibleOffsetNano = Number(utcEpochNano - possibleEpochNano);
    const possibleOffsetRefined = fuzzyMatching ? roundToMinute(possibleOffsetNano) : possibleOffsetNano;
    if (possibleOffsetRefined === roundedOffsetNano) {
      return possibleEpochNano;
    }
  }
}
function computeNanoInDay(fields) {
  const { timeZone } = fields;
  const day0 = { ...fields, ...zeroISOTimeFields, calendar: new Calendar("iso8601") };
  const day12 = { ...addDays(day0, 1), ...zeroISOTimeFields, calendar: new Calendar("iso8601") };
  const epochNano0 = timeZone.getInstantFor(createDateTime(day0)).epochNanoseconds;
  const epochNano1 = timeZone.getInstantFor(createDateTime(day12)).epochNanoseconds;
  return Number(epochNano1 - epochNano0);
}

// src/dateUtils/parseRegExp.ts
var yearMonthRegExpStr = "([+-]\\d{6}|\\d{4})-?(\\d{2})";
var dateRegExpStr = yearMonthRegExpStr + "-?(\\d{2})";
var monthDayRegExpStr = "(--)?(\\d{2})-?(\\d{2})";
var timeRegExpStr = "(\\d{2})(:?(\\d{2})(:?(\\d{2})([.,](\\d{1,9}))?)?)?";
var dateTimeRegExpStr = dateRegExpStr + "([T ]" + timeRegExpStr + ")?";
var offsetRegExpStr = "([+-])" + timeRegExpStr;
var endingRegExpStr = "(Z|" + offsetRegExpStr + ")?(\\[([^=\\]]+)\\])?(\\[u-ca=([^\\]]+)\\])?";
var yearMonthRegExp = createRegExp(yearMonthRegExpStr + endingRegExpStr);
var monthDayRegExp = createRegExp(monthDayRegExpStr + endingRegExpStr);
var dateTimeRegExp = createRegExp(dateTimeRegExpStr + endingRegExpStr);
var timeRegExp = createRegExp("T?" + timeRegExpStr + endingRegExpStr);
var offsetRegExp = createRegExp(offsetRegExpStr);
var durationRegExp = /^([-+])?P(\d+Y)?(\d+M)?(\d+W)?(\d+D)?(T((\d+)([.,](\d{1,9}))?H)?((\d+)([.,](\d{1,9}))?M)?((\d+)([.,](\d{1,9}))?S)?)?$/i;
var unicodeDashRegExp = /\u2212/g;
function createRegExp(meat) {
  return new RegExp(`^${meat}$`, "i");
}
function normalizeDashes(str) {
  return str.replace(unicodeDashRegExp, "-");
}

// src/dateUtils/parse.ts
function parseZonedDateTime(str) {
  const res = tryParseZonedDateTime(str);
  if (!res) {
    throw createParseError("dateTime", str);
  }
  return res;
}
function parseDateTime(str) {
  const res = tryParseDateTime(str);
  if (!res) {
    throw createParseError("dateTime", str);
  }
  return res;
}
function parseYearMonth(str) {
  const res = tryParseYearMonth(str) || tryParseDateTime(str);
  if (!res) {
    throw createParseError("yearMonth", str);
  }
  return res;
}
function parseMonthDay(str) {
  const res = tryParseMonthDay(str) || tryParseDateTime(str);
  if (!res) {
    throw createParseError("monthDay", str);
  }
  return res;
}
function parseOffsetNano(str) {
  const res = tryParseOffsetNano(str);
  if (res === void 0) {
    throw createParseError("timeZone", str);
  }
  return res;
}
function parseTime(str) {
  let res = tryParseTime(str);
  if (res !== void 0) {
    if (str.charAt(0) !== "T") {
      const tryOther = tryParseYearMonth(str) || tryParseMonthDay(str);
      if (tryOther && isValidDateISO(tryOther)) {
        res = void 0;
      }
    }
  } else {
    res = tryParseDateTime(str, true);
  }
  if (res === void 0) {
    throw createParseError("time", str);
  }
  return res;
}
var zRE = /^Z$/i;
function tryParseZonedDateTime(str) {
  const m = dateTimeRegExp.exec(normalizeDashes(str));
  if (m) {
    return parseZonedDateTimeParts(m.slice(1));
  }
}
function tryParseDateTime(str, requireTime, allowZ) {
  const m = dateTimeRegExp.exec(normalizeDashes(str));
  if (m && (allowZ || !zRE.test(m[12])) && (!requireTime || m[4])) {
    return parseDateTimeParts(m.slice(1));
  }
}
function tryParseYearMonth(str) {
  const m = yearMonthRegExp.exec(normalizeDashes(str));
  if (m) {
    return parseYearMonthParts(m.slice(1));
  }
}
function tryParseMonthDay(str) {
  const m = monthDayRegExp.exec(normalizeDashes(str));
  if (m) {
    return parseMonthDayParts(m.slice(1));
  }
}
function tryParseTime(str) {
  const m = timeRegExp.exec(normalizeDashes(str));
  if (m) {
    return parseTimeParts(m.slice(1));
  }
}
function tryParseOffsetNano(str) {
  const m = offsetRegExp.exec(normalizeDashes(str));
  if (m) {
    return parseOffsetParts(m.slice(1));
  }
}
function parseZonedDateTimeParts(parts) {
  const zOrOffset = parts[11];
  let offsetNanoseconds;
  let Z = false;
  if (zOrOffset) {
    Z = zRE.test(zOrOffset);
    offsetNanoseconds = Z ? 0 : parseOffsetParts(parts.slice(12));
  }
  return {
    ...parseDateTimeParts(parts),
    timeZone: parts[21],
    offsetNanoseconds,
    Z
  };
}
function parseDateTimeParts(parts) {
  return {
    calendar: parts[23],
    isoYear: toInt1(parts[0]),
    isoMonth: toInt1(parts[1]),
    isoDay: toInt1(parts[2]),
    ...parseTimeParts(parts.slice(4))
  };
}
function parseYearMonthParts(parts) {
  return {
    calendar: parts[14],
    isoYear: toInt1(parts[0]),
    isoMonth: toInt1(parts[1]),
    isoDay: 1
  };
}
function parseMonthDayParts(parts) {
  return {
    calendar: parts[15],
    isoYear: isoEpochLeapYear,
    isoMonth: toInt1(parts[1]),
    isoDay: toInt1(parts[2])
  };
}
function parseTimeParts(parts) {
  const isoSecond = toInt0(parts[4]);
  return {
    ...nanoToISOTime(parseNanoAfterDecimal(parts[6] || ""))[0],
    isoHour: toInt0(parts[0]),
    isoMinute: toInt0(parts[2]),
    isoSecond: isoSecond === 60 ? 59 : isoSecond
  };
}
function parseOffsetParts(parts) {
  return (parts[0] === "+" ? 1 : -1) * timePartsToNano(parts.slice(1));
}
function timePartsToNano(parts) {
  return toInt0(parts[0]) * nanoInHour + toInt0(parts[2]) * nanoInMinute + toInt0(parts[4]) * nanoInSecond + parseNanoAfterDecimal(parts[6] || "");
}
function parseNanoAfterDecimal(str) {
  return parseInt(str.padEnd(9, "0"));
}
function toInt0(input) {
  return parseInt(input || "0");
}
function toInt1(input) {
  return parseInt(input || "1");
}
function toIntMaybe(input) {
  return input === void 0 ? void 0 : parseInt(input);
}
function createParseError(type, str) {
  throw new RangeError(`Cannot parse ${type} '${str}'`);
}

// src/dateUtils/parseRefine.ts
function refineBaseObj(parsed) {
  return {
    ...parsed,
    calendar: parsed.calendar === void 0 ? createDefaultCalendar() : new Calendar(parsed.calendar)
  };
}
function refineZonedObj(parsed) {
  return {
    ...refineBaseObj(parsed),
    timeZone: new TimeZone(parsed.timeZone)
  };
}

// src/timeZoneImpl/timeZoneImpl.ts
var TimeZoneImpl = class {
  constructor(id) {
    this.id = id;
  }
};

// src/timeZoneImpl/fixedTimeZoneImpl.ts
var FixedTimeZoneImpl = class extends TimeZoneImpl {
  constructor(id, offsetNano) {
    super(id);
    this.offsetNano = offsetNano;
  }
  getPossibleOffsets() {
    return [this.offsetNano];
  }
  getOffset() {
    return this.offsetNano;
  }
  getTransition() {
    return void 0;
  }
};

// src/dateUtils/intlFormat.ts
function hashIntlFormatParts(format, epochMillisecond) {
  const hash = {};
  const parts = format.formatToParts(epochMillisecond);
  for (const part of parts) {
    hash[part.type] = part.value;
  }
  return hash;
}
var eraRemap = {
  bc: "bce",
  ad: "ce"
};
function normalizeShortEra(formattedEra) {
  formattedEra = formattedEra.toLowerCase().normalize("NFD").replace(/[^a-z0-9]/g, "");
  return eraRemap[formattedEra] || formattedEra;
}

// src/native/intlUtils.ts
var OrigDateTimeFormat = Intl.DateTimeFormat;
function normalizeAndCopyLocalesArg(localesArg) {
  return [].concat(localesArg || []);
}
function flattenOptions(options) {
  const newOptions = {};
  for (const name in options) {
    let val = options[name];
    if (isObjectLike(val)) {
      val = val.toString();
    }
    newOptions[name] = val;
  }
  return newOptions;
}

// src/timeZoneImpl/specialCases.ts
var specialCases = {
  "Pacific/Apia": {
    2011: [
      [1301752800000000000n, -36e12, -396e11],
      [1316872800000000000n, -396e11, -36e12],
      [1325239200000000000n, -36e12, 504e11]
    ]
  }
};

// src/timeZoneImpl/intlTimeZoneImpl.ts
var DST_EARLIEST_YEAR = 1847;
var DST_PERSIST_YEAR = new Date().getUTCFullYear() + 10;
var ISLAND_SEARCH_DAYS = [
  182,
  91,
  273
];
var IntlTimeZoneImpl = class extends TimeZoneImpl {
  constructor(id) {
    const format = new OrigDateTimeFormat("en-GB", {
      era: "short",
      year: "numeric",
      month: "numeric",
      day: "numeric",
      hour: "numeric",
      minute: "numeric",
      second: "numeric",
      timeZone: id
    });
    super(format.resolvedOptions().timeZone);
    this.format = format;
    this.yearEndOffsets = {};
    this.transitionsInYear = specialCases[id] || {};
  }
  getPossibleOffsets(zoneNano) {
    let lastOffsetNano;
    const transitions = [
      this.getTransition(zoneNano, -1),
      this.getTransition(zoneNano - 1n, 1)
    ].filter(Boolean);
    for (const transition of transitions) {
      const [transitionEpochNano, offsetNanoBefore, offsetNanoAfter] = transition;
      const epochNanoA = zoneNano - BigInt(offsetNanoBefore);
      const epochNanoB = zoneNano - BigInt(offsetNanoAfter);
      if (transitionEpochNano > epochNanoA && transitionEpochNano > epochNanoB) {
        return [offsetNanoBefore];
      } else if (transitionEpochNano <= epochNanoA && transitionEpochNano <= epochNanoB) {
      } else {
        return [offsetNanoBefore, offsetNanoAfter];
      }
      lastOffsetNano = offsetNanoAfter;
    }
    if (lastOffsetNano !== void 0) {
      return [lastOffsetNano];
    }
    return [
      this.getYearEndOffsetSec(epochNanoToISOYear(zoneNano)) * nanoInSecond
    ];
  }
  getOffset(epochNano) {
    return this.getOffsetForEpochSecs(Number(epochNano / nanoInSecondBI)) * nanoInSecond;
  }
  getOffsetForEpochSecs(epochSec) {
    const map = hashIntlFormatParts(this.format, epochSec * milliInSecond);
    let year = parseInt(map.year);
    if (normalizeShortEra(map.era) === "bce") {
      year = -(year - 1);
    }
    const zoneMilli = isoToEpochMilli(year, parseInt(map.month), parseInt(map.day), parseInt(map.hour), parseInt(map.minute), parseInt(map.second));
    const zoneSecs = Math.floor(zoneMilli / milliInSecond);
    return zoneSecs - epochSec;
  }
  getTransition(epochNano, direction) {
    let year = epochNanoToISOYear(epochNano);
    if (year > DST_PERSIST_YEAR) {
      const res = this.getTransitionFrom(year, year + direction, direction, epochNano);
      if (res || direction > 0) {
        return res;
      }
      year = DST_PERSIST_YEAR;
    }
    return this.getTransitionFrom(Math.max(year, DST_EARLIEST_YEAR), direction < 0 ? DST_EARLIEST_YEAR - 1 : DST_PERSIST_YEAR, direction, epochNano);
  }
  getTransitionFrom(year, endYear, direction, epochNano) {
    for (; year !== endYear; year += direction) {
      let transitions = this.getTransitionsInYear(year);
      if (direction < 0) {
        transitions = transitions.slice().reverse();
      }
      for (const transition of transitions) {
        if (compareValues(transition[0], epochNano) === direction) {
          return transition;
        }
      }
    }
  }
  getYearEndOffsetSec(utcYear) {
    const { yearEndOffsets } = this;
    return yearEndOffsets[utcYear] || (yearEndOffsets[utcYear] = this.getOffsetForEpochSecs(isoYearToEpochSeconds(utcYear + 1) - 1));
  }
  getTransitionsInYear(utcYear) {
    const { transitionsInYear } = this;
    return transitionsInYear[utcYear] || (transitionsInYear[utcYear] = this.computeTransitionsInYear(utcYear));
  }
  computeTransitionsInYear(utcYear) {
    const startOffsetSec = this.getYearEndOffsetSec(utcYear - 1);
    const endOffsetSec = this.getYearEndOffsetSec(utcYear);
    const startEpochSec = isoYearToEpochSeconds(utcYear) - 1;
    const endEpochSec = isoYearToEpochSeconds(utcYear + 1) - 1;
    if (startOffsetSec !== endOffsetSec) {
      return [this.searchTransition(startEpochSec, endEpochSec, startOffsetSec, endOffsetSec)];
    }
    const island = this.searchIsland(startOffsetSec, startEpochSec);
    if (island !== void 0) {
      return [
        this.searchTransition(startEpochSec, island[0], startOffsetSec, island[1]),
        this.searchTransition(island[0], endEpochSec, island[1], endOffsetSec)
      ];
    }
    return [];
  }
  searchTransition(startEpochSec, endEpochSec, startOffsetSec, endOffsetSec) {
    while (endEpochSec - startEpochSec > 1) {
      const middleEpochSecs = Math.floor(startEpochSec + (endEpochSec - startEpochSec) / 2);
      const middleOffsetSecs = this.getOffsetForEpochSecs(middleEpochSecs);
      if (middleOffsetSecs === startOffsetSec) {
        startEpochSec = middleEpochSecs;
      } else {
        endEpochSec = middleEpochSecs;
      }
    }
    return [
      BigInt(endEpochSec) * nanoInSecondBI,
      startOffsetSec * nanoInSecond,
      endOffsetSec * nanoInSecond
    ];
  }
  searchIsland(outerOffsetSec, startEpochSec) {
    for (const days of ISLAND_SEARCH_DAYS) {
      const epochSec = startEpochSec + days * secondsInDay;
      const offsetSec = this.getOffsetForEpochSecs(epochSec);
      if (offsetSec !== outerOffsetSec) {
        return [epochSec, offsetSec];
      }
    }
  }
};

// src/timeZoneImpl/timeZoneImplQuery.ts
var implCache = {
  UTC: new FixedTimeZoneImpl("UTC", 0)
};
function queryTimeZoneImpl(id) {
  id = String(id);
  const key = id.toLocaleUpperCase();
  if (implCache[key]) {
    return implCache[key];
  }
  const offsetNano = tryParseOffsetNano(id);
  if (offsetNano !== void 0) {
    if (Math.abs(offsetNano) > nanoInDay) {
      throw new RangeError("Offset out of bounds");
    }
    return new FixedTimeZoneImpl(formatOffsetISO(offsetNano), offsetNano);
  }
  return implCache[key] = new IntlTimeZoneImpl(id);
}

// src/public/timeZone.ts
var [getImpl, setImpl] = createWeakMap();
var TimeZone = class extends AbstractObj {
  constructor(id) {
    if (!id) {
      throw new RangeError("Invalid timezone ID");
    }
    super();
    setImpl(this, queryTimeZoneImpl(id));
  }
  static from(arg) {
    if (typeof arg === "object") {
      if (isTimeZoneArgBag(arg)) {
        return parseTimeZoneFromBag(arg.timeZone);
      } else {
        return arg;
      }
    }
    const parsed = tryParseZonedDateTime(String(arg));
    if (parsed) {
      if (parsed.timeZone) {
        const refined = refineZonedObj(parsed);
        checkInvalidOffset(refined);
        return refined.timeZone;
      } else if (parsed.Z) {
        return new TimeZone("UTC");
      } else if (parsed.offsetNanoseconds !== void 0) {
        return new TimeZone(formatOffsetISO(parsed.offsetNanoseconds));
      }
    }
    return new TimeZone(arg);
  }
  get id() {
    return this.toString();
  }
  getOffsetStringFor(instantArg) {
    return formatOffsetISO(this.getOffsetNanosecondsFor(instantArg));
  }
  getOffsetNanosecondsFor(instantArg) {
    const instant = ensureObj(Instant, instantArg);
    return getImpl(this).getOffset(instant.epochNanoseconds);
  }
  getPlainDateTimeFor(instantArg, calendarArg = createDefaultCalendar()) {
    const instant = ensureObj(Instant, instantArg);
    const isoFields = epochNanoToISOFields(instant.epochNanoseconds + BigInt(this.getOffsetNanosecondsFor(instant)));
    return createDateTime({
      ...isoFields,
      calendar: ensureObj(Calendar, calendarArg)
    });
  }
  getInstantFor(dateTimeArg, options) {
    const disambig = parseDisambigOption(options);
    const isoFields = ensureObj(PlainDateTime, dateTimeArg).getISOFields();
    const zoneNano = isoFieldsToEpochNano(isoFields);
    const possibleOffsetNanos = getImpl(this).getPossibleOffsets(zoneNano);
    let offsetNano;
    if (possibleOffsetNanos.length === 1 || disambig === DISAMBIG_COMPATIBLE) {
      offsetNano = possibleOffsetNanos[0];
    } else if (disambig === DISAMBIG_REJECT) {
      throw new RangeError("Ambiguous offset");
    } else {
      offsetNano = Math[disambig === DISAMBIG_EARLIER ? "max" : "min"](...possibleOffsetNanos);
    }
    return new Instant(zoneNano - BigInt(offsetNano));
  }
  getPossibleInstantsFor(dateTimeArg) {
    const isoFields = ensureObj(PlainDateTime, dateTimeArg).getISOFields();
    const zoneNano = isoFieldsToEpochNano(isoFields);
    let possibleOffsetNanos = getImpl(this).getPossibleOffsets(zoneNano);
    if (possibleOffsetNanos.length === 2 && possibleOffsetNanos[0] < possibleOffsetNanos[1]) {
      possibleOffsetNanos = [];
    }
    return possibleOffsetNanos.map((offsetNano) => new Instant(zoneNano - BigInt(offsetNano)));
  }
  getPreviousTransition(instantArg) {
    const instant = ensureObj(Instant, instantArg);
    const rawTransition = getImpl(this).getTransition(instant.epochNanoseconds, -1);
    if (rawTransition) {
      return new Instant(rawTransition[0]);
    }
    return null;
  }
  getNextTransition(instantArg) {
    const instant = ensureObj(Instant, instantArg);
    const rawTransition = getImpl(this).getTransition(instant.epochNanoseconds, 1);
    if (rawTransition) {
      return new Instant(rawTransition[0]);
    }
    return null;
  }
  toString() {
    return getImpl(this).id;
  }
};
attachStringTag(TimeZone, "TimeZone");

// src/argParse/timeZone.ts
function isTimeZoneArgBag(arg) {
  return arg.timeZone;
}
function parseTimeZoneFromBag(arg) {
  if (typeof arg === "object") {
    if (typeof arg.id === "string") {
      return arg;
    } else {
      throw new RangeError("Invalid timeZone");
    }
  }
  return new TimeZone(String(arg));
}
function extractTimeZone(input) {
  if (input.timeZone === void 0) {
    throw new TypeError("Must specify timeZone");
  }
  return ensureObj(TimeZone, input.timeZone);
}

// src/dateUtils/fromAndWith.ts
var processZonedDateTimeFromFields = buildSafeFunc(tryZonedDateTimeFromFields);
var processDateTimeFromFields = buildSafeFunc(tryDateTimeFromFields);
var processDateFromFields = buildSafeFunc(tryDateFromFields);
var processYearMonthFromFields = buildSafeFunc(tryYearMonthFromFields);
var processMonthDayFromFields = buildSafeFunc(tryMonthDayFromFields);
var processTimeFromFields = buildSafeFunc(tryTimeFromFields);
var processZonedDateTimeWithFields = buildSafeFunc(tryZonedDateTimeWithFields, true);
var processDateTimeWithFields = buildSafeFunc(tryDateTimeWithFields, true);
var processDateWithFields = buildSafeFunc(tryDateWithFields, true);
var processYearMonthWithFields = buildSafeFunc(tryYearMonthWithFields, true);
var processMonthDayWithFields = buildSafeFunc(tryMonthDayWithFields, true);
var processTimeWithFields = buildSafeFunc(tryTimeWithFields, true);
var processDurationFields = buildSafeFunc(tryDurationFields);
function tryZonedDateTimeFromFields(rawFields, overflowHandling, options) {
  const res = tryDateTimeFromFields(rawFields, overflowHandling, options);
  if (res) {
    return {
      ...res,
      timeZone: extractTimeZone(rawFields),
      offsetNanoseconds: rawFields.offset !== void 0 ? parseOffsetNano(String(rawFields.offset)) : void 0
    };
  }
}
function tryDateTimeFromFields(rawFields, overflowHandling, options) {
  const dateRes = tryDateFromFields(rawFields, options);
  const timeRes = tryTimeFromFields(rawFields, overflowHandling);
  if (dateRes) {
    return {
      ...dateRes.getISOFields(),
      ...timeRes || zeroISOTimeFields
    };
  }
}
function tryDateFromFields(rawFields, options) {
  const calendar = extractCalendar(rawFields);
  const filteredFields = filterFieldsViaCalendar(rawFields, dateFieldMap, calendar);
  if (hasAnyProps(filteredFields)) {
    return calendar.dateFromFields(filteredFields, options);
  }
}
function tryYearMonthFromFields(rawFields, options) {
  const calendar = extractCalendar(rawFields);
  const filteredFields = filterFieldsViaCalendar(rawFields, yearMonthFieldMap, calendar);
  if (hasAnyProps(filteredFields)) {
    return calendar.yearMonthFromFields(filteredFields, options);
  }
}
function tryMonthDayFromFields(rawFields, options) {
  const calendar = extractCalendar(rawFields);
  const filteredFields = filterFieldsViaCalendar(rawFields, monthDayFieldMap, calendar);
  if (hasAnyProps(filteredFields)) {
    if (rawFields.year === void 0 && rawFields.calendar === void 0) {
      filteredFields.year = isoEpochLeapYear;
    }
    return calendar.monthDayFromFields(filteredFields, options);
  }
}
function tryTimeFromFields(rawFields, overflowHandling) {
  const refinedFields = refineFields(rawFields, timeFieldMap);
  if (hasAnyProps(refinedFields)) {
    return constrainTimeISO(partialLocalTimeToISO(refinedFields), overflowHandling);
  }
}
function tryZonedDateTimeWithFields(zonedDateTime, rawFields, overflowHandling, options) {
  const res = tryDateTimeWithFields(zonedDateTime, rawFields, overflowHandling, options);
  const hasNewOffset = rawFields.offset !== void 0;
  if (res || hasNewOffset) {
    return {
      ...res || zonedDateTime.getISOFields(),
      timeZone: zonedDateTime.timeZone,
      offsetNanoseconds: hasNewOffset ? parseOffsetNano(String(rawFields.offset)) : zonedDateTime.offsetNanoseconds
    };
  }
}
function tryDateTimeWithFields(plainDateTime, rawFields, overflowHandling, options) {
  const dateRes = tryDateWithFields(plainDateTime, rawFields, options);
  const timeRes = tryTimeWithFields(plainDateTime, rawFields, overflowHandling);
  if (dateRes || timeRes) {
    return {
      ...plainDateTime.getISOFields(),
      ...dateRes ? dateRes.getISOFields() : {},
      ...timeRes
    };
  }
}
function tryDateWithFields(plainDate, rawFields, options) {
  const calendar = plainDate.calendar;
  const filteredFields = filterFieldsViaCalendar(rawFields, dateFieldMap, calendar);
  if (hasAnyProps(filteredFields)) {
    const mergedFields = mergeFieldsViaCalendar(plainDate, filteredFields, dateFieldMap, calendar);
    return calendar.dateFromFields(mergedFields, options);
  }
}
function tryYearMonthWithFields(plainYearMonth, rawFields, options) {
  const calendar = plainYearMonth.calendar;
  const filteredFields = filterFieldsViaCalendar(rawFields, yearMonthFieldMap, calendar);
  if (hasAnyProps(filteredFields)) {
    const mergedFields = mergeFieldsViaCalendar(plainYearMonth, rawFields, yearMonthFieldMap, calendar);
    return calendar.yearMonthFromFields(mergedFields, options);
  }
}
function tryMonthDayWithFields(plainMonthDay, rawFields, options) {
  const calendar = plainMonthDay.calendar;
  const filteredFields = filterFieldsViaCalendar(rawFields, monthDayFieldMap, calendar);
  if (hasAnyProps(filteredFields)) {
    const mergedFields = mergeFieldsViaCalendar(plainMonthDay, rawFields, monthDayFieldMap, calendar);
    return calendar.monthDayFromFields(mergedFields, options);
  }
}
function tryTimeWithFields(plainTime, rawFields, overflowHandling) {
  const refinedFields = refineFields(rawFields, timeFieldMap);
  if (hasAnyProps(refinedFields)) {
    const mergedFields = mergeLocalTimeFields(plainTime, refinedFields);
    return constrainTimeISO(partialLocalTimeToISO(mergedFields), overflowHandling);
  }
}
function tryDurationFields(rawFields) {
  const refinedFields = refineFields(rawFields, durationFieldMap);
  if (hasAnyProps(refinedFields)) {
    return refinedFields;
  }
}
function filterFieldsViaCalendar(objOrFields, fieldMap, calendar) {
  let fieldNames = Object.keys(fieldMap);
  if (calendar.fields) {
    fieldNames = calendar.fields(fieldNames);
  } else {
    fieldNames = Object.keys(filterFieldsViaWhitelist(calendar, fieldNames));
  }
  return filterFieldsViaWhitelist(objOrFields, fieldNames);
}
function filterFieldsViaWhitelist(objOrFields, whitelist) {
  const filtered = {};
  for (const propName of whitelist) {
    if (objOrFields[propName] !== void 0) {
      filtered[propName] = objOrFields[propName];
    }
  }
  return filtered;
}
function mergeFieldsViaCalendar(existingObj, fields, fieldMap, calendar) {
  const existingFields = filterFieldsViaCalendar(existingObj, fieldMap, calendar);
  if (calendar.mergeFields) {
    return calendar.mergeFields(existingFields, fields);
  }
  return mergeCalFields(existingFields, fields);
}
function mergeLocalTimeFields(base, fields) {
  return mapHash(timeFieldMap, (_refineFunc, fieldName) => fields[fieldName] ?? base[fieldName]);
}
function buildSafeFunc(func, isWith) {
  return (...args) => {
    if (isWith) {
      const rawFields = args[1];
      if (!isObjectLike(rawFields)) {
        throw new TypeError("must be object-like");
      }
      if (rawFields.calendar !== void 0) {
        throw new TypeError("calendar not allowed");
      }
      if (rawFields.timeZone !== void 0) {
        throw new TypeError("timeZone not allowed");
      }
    }
    const res = func(...args);
    if (!res) {
      throw new TypeError("No valid fields");
    }
    return res;
  };
}
function hasAnyProps(fields) {
  return Object.keys(fields).length > 0;
}

// src/dateUtils/isoFieldValidation.ts
function validateYearMonth(isoFields, calendarID) {
  const epochNano = isoFieldsToEpochNano(isoFields);
  checkEpochNanoBuggy(epochNano, calendarID);
}
function validateDate(isoFields, calendarID) {
  const epochNano = isoFieldsToEpochNano(isoFields);
  validatePlain(epochNano + (epochNano < 0n ? 86399999999999n : 0n));
  checkEpochNanoBuggy(epochNano, calendarID);
}
function validateDateTime(isoFields, calendarID) {
  const epochNano = isoFieldsToEpochNano(isoFields);
  validatePlain(epochNano);
  checkEpochNanoBuggy(epochNano, calendarID);
}
function validateInstant(epochNano) {
  if (epochNano < -8640000000000000000000n || epochNano > 8640000000000000000000n) {
    throwOutOfRange();
  }
}
function validatePlain(epochNano) {
  if (epochNano < -8640000086399999999999n || epochNano > 8640000086399999999999n) {
    throwOutOfRange();
  }
}

// src/dateUtils/rounding.ts
function roundDateTime(fields, roundingConfig) {
  const timeNano = isoTimeToNano(fields);
  const roundedTimeNano = roundNano(timeNano, roundingConfig);
  const [isoTimeFields, dayDelta] = nanoToISOTime(roundedTimeNano);
  const dayStartTranslated = addDays(fields, dayDelta);
  return { ...dayStartTranslated, ...isoTimeFields };
}
function roundTime(fields, roundingConfig) {
  const timeNano = isoTimeToNano(fields);
  const roundedTimeNano = roundNano(timeNano, roundingConfig);
  const [isoTimeFields] = nanoToISOTime(roundedTimeNano);
  return isoTimeFields;
}
function roundEpochNano(epochNano, roundingConfig) {
  const [dayEpochNano, timeNano] = splitEpochNano(epochNano);
  const roundedTimeNano = roundNano(timeNano, roundingConfig);
  return dayEpochNano + BigInt(roundedTimeNano);
}
function roundZonedDateTimeFields(fields, offsetNanoseconds, roundingConfig) {
  const { calendar, timeZone } = fields;
  let timeNano = isoTimeToNano(fields);
  let isoTimeFields;
  let dayDelta;
  if (roundingConfig.smallestUnit === DAY) {
    isoTimeFields = zeroISOTimeFields;
    dayDelta = roundingConfig.roundingFunc(timeNano / computeNanoInDay(fields));
  } else {
    timeNano = roundNano(timeNano, roundingConfig);
    [isoTimeFields, dayDelta] = nanoToISOTime(timeNano);
  }
  const dayStartTranslated = addDays(fields, dayDelta);
  return computeZonedDateTimeEpochNano({
    ...dayStartTranslated,
    ...isoTimeFields,
    offsetNanoseconds,
    calendar,
    timeZone
  }, false, OFFSET_PREFER);
}
function roundNano(nano, roundingConfig) {
  return roundToIncrement(nano, roundingConfig.incNano, roundingConfig.roundingFunc);
}

// src/native/intlFactory.ts
function createZonedFormatFactoryFactory(greedyDefaults, nonGreedyDefaults, finalOptions) {
  return (locales, options) => {
    const defaults = anyDefaultsOverridden(greedyDefaults, options) ? {} : { ...greedyDefaults, ...nonGreedyDefaults };
    function buildFormat2(calendarID, timeZoneID) {
      return new OrigDateTimeFormat(locales, {
        calendar: calendarID,
        timeZone: timeZoneID || void 0,
        ...defaults,
        ...options,
        ...finalOptions
      });
    }
    return {
      buildKey: createKeyFactory(locales, options, false),
      buildFormat: buildFormat2,
      buildEpochMilli: getEpochMilliFromZonedEntity
    };
  };
}
function getEpochMilliFromZonedEntity(entity) {
  return entity.epochMilliseconds;
}
function createPlainFormatFactoryFactory(greedyDefaults, finalOptions, strictCalendar) {
  return (locales, options) => {
    const defaults = anyDefaultsOverridden(greedyDefaults, options) ? {} : greedyDefaults;
    function buildFormat2(calendarID, timeZoneID) {
      return new OrigDateTimeFormat(locales, {
        calendar: calendarID,
        ...defaults,
        ...options,
        ...finalOptions,
        timeZone: timeZoneID,
        timeZoneName: void 0
      });
    }
    return {
      buildKey: createKeyFactory(locales, options, strictCalendar),
      buildFormat: buildFormat2,
      buildEpochMilli: options.timeZone !== void 0 ? computeEpochMilliViaTimeZone.bind(null, new TimeZone(options.timeZone)) : computeEpochMilliViaISO
    };
  };
}
function computeEpochMilliViaTimeZone(timeZone, entity) {
  const plainDateTime = createDateTime({
    ...zeroISOTimeFields,
    ...entity.getISOFields()
  });
  return timeZone.getInstantFor(plainDateTime).epochMilliseconds;
}
function computeEpochMilliViaISO(entity) {
  return isoFieldsToEpochMilli(entity.getISOFields());
}
function buildCachedFormatFactory(formatFactory) {
  const cachedFormats = {};
  function buildFormat2(entity, otherEntity) {
    const keys = formatFactory.buildKey(entity, otherEntity);
    const key = keys.join("|");
    return cachedFormats[key] || (cachedFormats[key] = formatFactory.buildFormat(...keys));
  }
  return {
    buildFormat: buildFormat2,
    buildEpochMilli: formatFactory.buildEpochMilli
  };
}
function createKeyFactory(locales, options, strictCalendar) {
  const optionsCalendarID = options.calendar ?? extractUnicodeCalendar(locales);
  const optionsTimeZoneID = options.timeZone;
  return function(entity, otherEntity) {
    const entityCalendarID = entity.calendar?.id;
    const entityTimeZoneID = entity.timeZone?.id;
    if (otherEntity) {
      if (otherEntity.calendar?.id !== entityCalendarID) {
        throw new RangeError("Mismatching calendar");
      }
      if (otherEntity.timeZone?.id !== entityTimeZoneID) {
        throw new RangeError("Mismatching timeZone");
      }
    }
    if ((strictCalendar || entityCalendarID !== isoCalendarID) && entityCalendarID !== void 0 && optionsCalendarID !== void 0 && optionsCalendarID !== entityCalendarID) {
      throw new RangeError("Non-iso calendar mismatch");
    }
    if (entityTimeZoneID !== void 0 && optionsTimeZoneID !== void 0 && optionsTimeZoneID !== entityTimeZoneID) {
      throw new RangeError("Given timeZone must agree");
    }
    const calendarID = optionsCalendarID || entityCalendarID || isoCalendarID;
    const timeZoneID = optionsTimeZoneID || entityTimeZoneID || "UTC";
    return [calendarID, timeZoneID];
  };
}
function extractUnicodeCalendar(locales) {
  for (const locale of locales) {
    const m = locale.match(/-u-ca-(.*)$/);
    if (m) {
      return m[1];
    }
  }
  return void 0;
}
function anyDefaultsOverridden(defaults, overrides) {
  for (const propName in defaults) {
    if (overrides[propName] !== void 0) {
      return true;
    }
  }
  return false;
}

// src/native/intlMixins.ts
function mixinLocaleStringMethods(ObjClass, buildFormatFactory) {
  ObjClass.prototype.toLocaleString = function(localesArg, options) {
    const formatFactory = buildFormatFactory(normalizeAndCopyLocalesArg(localesArg), options || {});
    return formatFactory.buildFormat(...formatFactory.buildKey(this)).format(formatFactory.buildEpochMilli(this));
  };
  ObjClass.prototype[formatFactoryFactorySymbol] = buildFormatFactory;
}
function extractFormatFactoryFactory(obj) {
  return obj?.[formatFactoryFactorySymbol];
}

// src/argParse/totalOptions.ts
function parseTotalConfig(optionsArg) {
  let relativeTo;
  let unitName;
  if (typeof optionsArg === "string") {
    unitName = optionsArg;
  } else {
    unitName = ensureOptionsObj(optionsArg).unit;
    relativeTo = optionsArg.relativeTo;
  }
  return {
    unit: parseUnit(unitName, void 0, NANOSECOND, YEAR),
    relativeTo
  };
}

// src/dateUtils/parseDuration.ts
function parseDuration(str) {
  const res = tryParseDuration(str);
  if (res === void 0) {
    throw createParseError("duration", str);
  }
  return res;
}
function tryParseDuration(str) {
  const match = durationRegExp.exec(normalizeDashes(str));
  if (match) {
    let hours;
    let minutes;
    let seconds;
    let leftoverNano;
    [hours, leftoverNano] = parseDurationTimeUnit(match[8], match[10], HOUR, void 0);
    [minutes, leftoverNano] = parseDurationTimeUnit(match[12], match[14], MINUTE, leftoverNano);
    [seconds, leftoverNano] = parseDurationTimeUnit(match[16], match[18], SECOND, leftoverNano);
    const fields = excludeUndefined({
      years: toIntMaybe(match[2]),
      months: toIntMaybe(match[3]),
      weeks: toIntMaybe(match[4]),
      days: toIntMaybe(match[5]),
      hours,
      minutes,
      seconds
    });
    if (!Object.keys(fields).length) {
      throw new RangeError("Duration string must have at least one field");
    }
    const small = nanoToDuration(BigInt(leftoverNano || 0), MILLISECOND);
    fields.milliseconds = small.milliseconds;
    fields.microseconds = small.microseconds;
    fields.nanoseconds = small.nanoseconds;
    let signedDuration = signDuration(fields);
    if (match[1] === "-") {
      signedDuration = negateDuration(signedDuration);
    }
    return signedDuration;
  }
}
function parseDurationTimeUnit(beforeDecimal, afterDecimal, unit, leftoverNano) {
  if (beforeDecimal !== void 0) {
    if (leftoverNano !== void 0) {
      throw new RangeError("Partial units must be last unit");
    }
    return [
      parseInt(beforeDecimal),
      afterDecimal !== void 0 ? parseNanoAfterDecimal(afterDecimal) * (nanoIn[unit] / nanoInSecond) : void 0
    ];
  } else if (leftoverNano !== void 0) {
    const wholeUnits = Math.trunc(leftoverNano / nanoIn[unit]);
    return [wholeUnits, leftoverNano - wholeUnits * nanoIn[unit]];
  } else {
    return [void 0, void 0];
  }
}

// src/argParse/offsetDisplay.ts
var OFFSET_DISPLAY_AUTO = 0;
var offsetDisplayMap = {
  auto: 0,
  never: 1
};
var parseOffsetDisplayOption = createOptionParser("offset", offsetDisplayMap, OFFSET_DISPLAY_AUTO);

// src/public/plainTime.ts
var PlainTime = class extends AbstractISOObj {
  constructor(isoHour = 0, isoMinute = 0, isoSecond = 0, isoMillisecond = 0, isoMicrosecond = 0, isoNanosecond = 0) {
    super({
      ...constrainTimeISO({
        isoHour,
        isoMinute,
        isoSecond,
        isoMillisecond,
        isoMicrosecond,
        isoNanosecond
      }, OVERFLOW_REJECT),
      calendar: createDefaultCalendar()
    });
  }
  static from(arg, options) {
    const overflowHandling = parseOverflowOption(options);
    return createTime(arg instanceof PlainTime ? arg.getISOFields() : typeof arg === "object" ? processTimeFromFields(arg, overflowHandling) : parseTime(String(arg)));
  }
  static compare(a, b) {
    return compareTimes(ensureObj(PlainTime, a), ensureObj(PlainTime, b));
  }
  with(fields, options) {
    return createTime(processTimeWithFields(this, fields, parseOverflowOption(options)));
  }
  add(durationArg) {
    return translatePlainTime(this, ensureObj(Duration, durationArg));
  }
  subtract(durationArg) {
    return translatePlainTime(this, negateDuration(ensureObj(Duration, durationArg)));
  }
  until(other, options) {
    return diffPlainTimes(this, ensureObj(PlainTime, other), options);
  }
  since(other, options) {
    return diffPlainTimes(ensureObj(PlainTime, other), this, options);
  }
  round(options) {
    const roundingConfig = parseRoundingOptions(options, void 0, NANOSECOND, HOUR);
    return createTime(roundTime(this.getISOFields(), roundingConfig));
  }
  equals(other) {
    return !compareTimes(this, ensureObj(PlainTime, other));
  }
  toString(options) {
    const formatConfig = parseTimeToStringOptions(options);
    const roundedISOFields = roundTime(this.getISOFields(), formatConfig);
    return formatTimeISO(roundedISOFields, formatConfig);
  }
  toZonedDateTime(options) {
    const plainDate = ensureObj(PlainDate, options.plainDate);
    const timeZone = ensureObj(TimeZone, options.timeZone);
    return createZonedDateTimeFromFields({
      ...plainDate.getISOFields(),
      ...this.getISOFields(),
      timeZone
    });
  }
  toPlainDateTime(dateArg) {
    return ensureObj(PlainDate, dateArg).toPlainDateTime(this);
  }
};
attachStringTag(PlainTime, "PlainTime");
mixinISOFields(PlainTime, timeUnitNames);
mixinLocaleStringMethods(PlainTime, createPlainTimeFormatFactory);
function createPlainTimeFormatFactory(locales, options) {
  return {
    buildKey: () => ["", ""],
    buildFormat: () => new OrigDateTimeFormat(locales, {
      hour: "numeric",
      minute: "2-digit",
      second: "2-digit",
      ...options,
      timeZone: "UTC",
      timeZoneName: void 0,
      year: void 0,
      month: void 0,
      day: void 0,
      weekday: void 0
    }),
    buildEpochMilli: (plainTime) => Math.trunc(isoTimeToNano(plainTime.getISOFields()) / nanoInMilli)
  };
}
function createTime(isoFields) {
  return new PlainTime(isoFields.isoHour, isoFields.isoMinute, isoFields.isoSecond, isoFields.isoMillisecond, isoFields.isoMicrosecond, isoFields.isoNanosecond);
}
function ensureLooseTime(arg) {
  return ensureObj(PlainTime, arg ?? { hour: 0 });
}
function translatePlainTime(pt, dur) {
  return createTime(translateTime(pt.getISOFields(), dur));
}
function diffPlainTimes(pt0, pt1, options) {
  const diffConfig = parseDiffOptions(options, HOUR, NANOSECOND, NANOSECOND, HOUR);
  return createDuration(diffTimes(pt0.getISOFields(), pt1.getISOFields(), diffConfig));
}

// src/public/plainYearMonth.ts
var day1 = { day: 1 };
var PlainYearMonth = class extends AbstractISOObj {
  constructor(isoYear, isoMonth, calendarArg = createDefaultCalendar(), referenceISODay = 1) {
    const constrained = constrainDateISO({
      isoYear,
      isoMonth,
      isoDay: referenceISODay
    }, OVERFLOW_REJECT);
    const calendar = ensureObj(Calendar, calendarArg);
    validateYearMonth(constrained, calendar.id);
    super({
      ...constrained,
      calendar
    });
  }
  static from(arg, options) {
    parseOverflowOption(options);
    if (arg instanceof PlainYearMonth) {
      return createYearMonth(arg.getISOFields());
    }
    if (typeof arg === "object") {
      return processYearMonthFromFields(arg, options);
    }
    const parsed = parseYearMonth(String(arg));
    if (parsed.calendar === void 0) {
      parsed.isoDay = 1;
    }
    return createYearMonth(refineBaseObj(parsed));
  }
  static compare(a, b) {
    return compareDateTimes(ensureObj(PlainYearMonth, a), ensureObj(PlainYearMonth, b));
  }
  with(fields, options) {
    return processYearMonthWithFields(this, fields, options);
  }
  add(durationArg, options) {
    return translatePlainYearMonth(this, ensureObj(Duration, durationArg), options);
  }
  subtract(durationArg, options) {
    return translatePlainYearMonth(this, negateDuration(ensureObj(Duration, durationArg)), options);
  }
  until(other, options) {
    return diffPlainYearMonths(this, ensureObj(PlainYearMonth, other), false, options);
  }
  since(other, options) {
    return diffPlainYearMonths(this, ensureObj(PlainYearMonth, other), true, options);
  }
  equals(other) {
    return !compareDateTimes(this, ensureObj(PlainYearMonth, other));
  }
  toString(options) {
    const fields = this.getISOFields();
    const calendarID = fields.calendar.toString();
    const calendarDisplay = parseCalendarDisplayOption(options);
    return (calendarID === isoCalendarID ? formatYearMonthISO(fields) : formatDateISO(fields)) + formatCalendarID(calendarID, calendarDisplay);
  }
  toPlainDate(fields) {
    return this.calendar.dateFromFields({
      year: this.year,
      month: this.month,
      day: fields.day
    });
  }
};
attachStringTag(PlainYearMonth, "PlainYearMonth");
mixinISOFields(PlainYearMonth);
mixinCalendarFields(PlainYearMonth, yearMonthCalendarFields);
mixinLocaleStringMethods(PlainYearMonth, createPlainFormatFactoryFactory({
  year: "numeric",
  month: "numeric"
}, {
  weekday: void 0,
  day: void 0,
  hour: void 0,
  minute: void 0,
  second: void 0
}, true));
function createYearMonth(isoFields) {
  return new PlainYearMonth(isoFields.isoYear, isoFields.isoMonth, isoFields.calendar, isoFields.isoDay);
}
function translatePlainYearMonth(yearMonth, duration, options) {
  return yearMonth.toPlainDate({
    day: duration.sign < 0 ? yearMonth.daysInMonth : 1
  }).add(duration, options).toPlainYearMonth();
}
function diffPlainYearMonths(pym0, pym1, flip, options) {
  return createDuration(diffDates(pym0.toPlainDate(day1), pym1.toPlainDate(day1), getCommonCalendar(pym0, pym1), flip, parseDiffOptions(options, YEAR, MONTH, MONTH, YEAR)));
}

// src/public/zonedDateTime.ts
var [getPrivateFields, setPrivateFields] = createWeakMap();
var ZonedDateTime2 = class extends AbstractISOObj {
  constructor(epochNanoseconds, timeZoneArg, calendarArg = createDefaultCalendar()) {
    const timeZone = ensureObj(TimeZone, timeZoneArg);
    const calendar = ensureObj(Calendar, calendarArg);
    const [isoFields, offsetNano] = buildZonedDateTimeISOFields(epochNanoseconds, timeZone);
    validateDateTime(isoFields, calendar.id);
    super({
      ...isoFields,
      calendar,
      timeZone,
      offset: formatOffsetISO(offsetNano)
    });
    setPrivateFields(this, {
      epochNanoseconds,
      offsetNanoseconds: offsetNano
    });
  }
  static from(arg, options) {
    const offsetHandling = parseOffsetHandlingOption(options, OFFSET_REJECT);
    const overflowHandling = parseOverflowOption(options);
    if (arg instanceof ZonedDateTime2) {
      return new ZonedDateTime2(arg.epochNanoseconds, arg.timeZone, arg.calendar);
    }
    const isObject = typeof arg === "object";
    const fields = isObject ? processZonedDateTimeFromFields(arg, overflowHandling, options) : refineZonedObj(parseZonedDateTime(String(arg)));
    return createZonedDateTimeFromFields(fields, !isObject, offsetHandling, options);
  }
  static compare(a, b) {
    return compareEpochObjs(ensureObj(ZonedDateTime2, a), ensureObj(ZonedDateTime2, b));
  }
  get timeZone() {
    return this.getISOFields().timeZone;
  }
  get epochNanoseconds() {
    return getPrivateFields(this).epochNanoseconds;
  }
  get offsetNanoseconds() {
    return getPrivateFields(this).offsetNanoseconds;
  }
  get offset() {
    return this.getISOFields().offset;
  }
  with(fields, options) {
    parseDisambigOption(options);
    const overflowHandling = parseOverflowOption(options);
    const offsetHandling = parseOffsetHandlingOption(options, OFFSET_PREFER);
    const refined = processZonedDateTimeWithFields(this, fields, overflowHandling, options);
    return createZonedDateTimeFromFields(refined, false, offsetHandling, options);
  }
  withPlainDate(dateArg) {
    const date = ensureObj(PlainDate, dateArg);
    const dateTime = date.toPlainDateTime(this);
    const { timeZone } = this;
    const instant = timeZone.getInstantFor(dateTime);
    return new ZonedDateTime2(instant.epochNanoseconds, timeZone, getStrangerCalendar(this, date));
  }
  withPlainTime(timeArg) {
    return createZonedDateTimeFromFields({
      ...this.getISOFields(),
      ...timeArg === void 0 ? zeroISOTimeFields : ensureObj(PlainTime, timeArg).getISOFields()
    });
  }
  withCalendar(calendarArg) {
    return new ZonedDateTime2(this.epochNanoseconds, this.timeZone, calendarArg);
  }
  withTimeZone(timeZoneArg) {
    return new ZonedDateTime2(this.epochNanoseconds, timeZoneArg, this.calendar);
  }
  add(durationArg, options) {
    return translateZonedDateTime(this, ensureObj(Duration, durationArg), options);
  }
  subtract(durationArg, options) {
    return translateZonedDateTime(this, negateDuration(ensureObj(Duration, durationArg)), options);
  }
  until(other, options) {
    return diffZonedDateTimes(this, ensureObj(ZonedDateTime2, other), false, options);
  }
  since(other, options) {
    return diffZonedDateTimes(this, ensureObj(ZonedDateTime2, other), true, options);
  }
  round(options) {
    const roundingConfig = parseRoundingOptions(options, void 0, NANOSECOND, DAY);
    return roundZonedDateTime(this, roundingConfig);
  }
  equals(other) {
    return zonedDateTimesEqual(this, ensureObj(ZonedDateTime2, other));
  }
  startOfDay() {
    return createZonedDateTimeFromFields({
      ...this.getISOFields(),
      ...zeroISOTimeFields,
      offsetNanoseconds: this.offsetNanoseconds
    }, false, OFFSET_PREFER);
  }
  get hoursInDay() {
    return computeNanoInDay(this.getISOFields()) / nanoInHour;
  }
  toString(options) {
    const formatConfig = parseTimeToStringOptions(options);
    const offsetDisplay = parseOffsetDisplayOption(options);
    const timeZoneDisplay = parseTimeZoneDisplayOption(options);
    const calendarDisplay = parseCalendarDisplayOption(options);
    const roundedZdt = roundZonedDateTime(this, formatConfig);
    return formatDateTimeISO(roundedZdt.getISOFields(), formatConfig) + (offsetDisplay === OFFSET_DISPLAY_AUTO ? formatOffsetISO(roundToMinute(roundedZdt.offsetNanoseconds)) : "") + formatTimeZoneID(this.timeZone.toString(), timeZoneDisplay) + formatCalendarID(this.calendar.toString(), calendarDisplay);
  }
  toPlainYearMonth() {
    return createYearMonth(this.getISOFields());
  }
  toPlainMonthDay() {
    return this.calendar.monthDayFromFields(this);
  }
  toPlainDateTime() {
    return createDateTime(this.getISOFields());
  }
  toPlainDate() {
    return createDate(this.getISOFields());
  }
  toPlainTime() {
    return createTime(this.getISOFields());
  }
  toInstant() {
    return new Instant(this.epochNanoseconds);
  }
};
attachStringTag(ZonedDateTime2, "ZonedDateTime");
mixinISOFields(ZonedDateTime2, timeUnitNames);
mixinCalendarFields(ZonedDateTime2, dateCalendarFields);
mixinEpochFields(ZonedDateTime2);
mixinLocaleStringMethods(ZonedDateTime2, createZonedFormatFactoryFactory({
  year: "numeric",
  month: "numeric",
  day: "numeric",
  weekday: void 0,
  hour: "numeric",
  minute: "2-digit",
  second: "2-digit"
}, {
  timeZoneName: "short"
}, {}));
function createZonedDateTimeFromFields(fields, fuzzyMatching, offsetHandling, disambigOptions) {
  const epochNano = computeZonedDateTimeEpochNano(fields, fuzzyMatching, offsetHandling, disambigOptions);
  return new ZonedDateTime2(epochNano, fields.timeZone, fields.calendar);
}
function buildZonedDateTimeISOFields(epochNano, timeZone) {
  const instant = new Instant(epochNano);
  const offsetNano = timeZone.getOffsetNanosecondsFor(instant);
  const isoFields = epochNanoToISOFields(epochNano + BigInt(offsetNano));
  return [isoFields, offsetNano];
}
function translateZonedDateTime(zdt, dur, options) {
  const isoFields = zdt.getISOFields();
  const epochNano = translateZonedDateTimeFields(isoFields, dur, options);
  return new ZonedDateTime2(epochNano, isoFields.timeZone, isoFields.calendar);
}
function roundZonedDateTime(zdt, roundingConfig) {
  const isoFields = zdt.getISOFields();
  const epochNano = roundZonedDateTimeFields(isoFields, zdt.offsetNanoseconds, roundingConfig);
  return new ZonedDateTime2(epochNano, isoFields.timeZone, isoFields.calendar);
}
function diffZonedDateTimes(dt0, dt1, flip, options) {
  const diffConfig = parseDiffOptions(options, HOUR, NANOSECOND, NANOSECOND, YEAR);
  const { largestUnit } = diffConfig;
  if (largestUnit >= DAY && dt0.timeZone.id !== dt1.timeZone.id) {
    throw new Error("Must be same timeZone");
  }
  return createDuration(diffDateTimes(dt0, dt1, getCommonCalendar(dt0, dt1), flip, diffConfig));
}

// src/dateUtils/relativeTo.ts
function extractRelativeTo(arg) {
  if (arg === void 0) {
    return void 0;
  }
  if (isObjectLike(arg)) {
    if (arg instanceof ZonedDateTime2 || arg instanceof PlainDateTime) {
      return arg;
    }
    return ensureObj(arg.timeZone !== void 0 ? ZonedDateTime2 : PlainDateTime, arg);
  }
  if (typeof arg === "symbol") {
    throw new TypeError("Incorrect relativeTo type");
  }
  const parsed = tryParseZonedDateTime(String(arg));
  if (parsed) {
    if (parsed.timeZone !== void 0) {
      return createZonedDateTimeFromFields(refineZonedObj(parsed), true);
    } else {
      return createDateTime(refineBaseObj(parsed));
    }
  }
  throw new RangeError("Invalid value of relativeTo");
}

// src/dateUtils/durationSpan.ts
function spanDurationFrom(duration, largestUnit, relativeTo, calendar) {
  return (relativeTo instanceof PlainDate ? spanDurationFromDate(duration, Math.max(DAY, largestUnit), relativeTo, calendar) : spanDurationFromDateTime(duration, largestUnit, relativeTo, calendar))[0];
}
function spanDurationFromDate(duration, largestUnit, relativeTo, calendar) {
  const translated = relativeTo.add(duration);
  const newDuration = calendar.dateUntil(relativeTo, translated, {
    largestUnit: unitNames[largestUnit]
  });
  return [newDuration, translated];
}
function spanDurationFromDateTime(fields, largestUnit, relativeTo, calendar, dissolveWeeks) {
  const forcedWeeks = dissolveWeeks !== true && largestUnit > WEEK && fields.weeks;
  if (forcedWeeks) {
    fields = overrideDuration(fields, { weeks: 0 });
  }
  let translated = relativeTo.add(fields);
  let balancedDuration = diffAccurate(relativeTo, translated, calendar, largestUnit);
  if (forcedWeeks) {
    balancedDuration = overrideDuration(balancedDuration, { weeks: forcedWeeks });
    translated = translated.add({ weeks: forcedWeeks });
  }
  return [balancedDuration, translated];
}

// src/dateUtils/totalUnits.ts
function computeTotalUnits(duration, unit, relativeTo, calendar) {
  if (relativeTo === void 0 && computeLargestDurationUnit(duration) <= DAY && isDayTimeUnit(unit)) {
    return Number(durationDayTimeToNano(duration)) / nanoIn[unit];
  }
  if (!relativeTo) {
    throw new RangeError("Need relativeTo");
  }
  const [balancedDuration, relativeToTranslated] = spanDurationFromDateTime(duration, unit, relativeTo, calendar, true);
  const durationLike = computeExactDuration(balancedDuration, unit, relativeTo, relativeToTranslated);
  const unitName = durationUnitNames[unit];
  return durationLike[unitName];
}
function computeExactDuration(balancedDuration, smallestUnit, dt0, dt1) {
  const smallestUnitName = durationUnitNames[smallestUnit];
  const { sign } = balancedDuration;
  if (!sign) {
    return balancedDuration;
  }
  const dur = {};
  for (let unit = YEAR; unit >= smallestUnit; unit--) {
    const durationUnit = durationUnitNames[unit];
    dur[durationUnit] = balancedDuration[durationUnit];
  }
  const incDur = { [smallestUnitName]: sign };
  const startDateTime = dt0.add(dur);
  const endDateTime = startDateTime.add(incDur);
  const startNano = toEpochNano(startDateTime);
  const endNano = toEpochNano(endDateTime);
  const middleNano = toEpochNano(dt1);
  const unitFrac = Number(middleNano - startNano) / Number(endNano - startNano) * sign;
  dur[smallestUnitName] += unitFrac;
  return dur;
}

// src/dateUtils/roundingDuration.ts
function roundDuration(duration, diffConfig, relativeTo, calendar) {
  const { largestUnit, smallestUnit, roundingIncrement, roundingFunc } = diffConfig;
  if (relativeTo === void 0 && computeLargestDurationUnit(duration) <= DAY && isDayTimeUnit(largestUnit) && isDayTimeUnit(smallestUnit)) {
    const nano = roundToIncrementBI(durationDayTimeToNano(duration), nanoIn[smallestUnit] * roundingIncrement, roundingFunc);
    return nanoToDuration(nano, largestUnit);
  }
  if (!relativeTo) {
    throw new RangeError("Need relativeTo");
  }
  const [spannedDuration, relativeToTranslated] = spanDurationFromDateTime(duration, largestUnit, relativeTo, calendar);
  return roundDurationSpan(spannedDuration, relativeTo, relativeToTranslated, calendar, false, diffConfig);
}
function roundDurationSpan(spannedDuration, d0, d1, calendar, flip, diffConfig) {
  const { largestUnit, smallestUnit, roundingIncrement, roundingFunc } = diffConfig;
  if (!isDateUnit(largestUnit)) {
    const diffNano = (toEpochNano(d1) - toEpochNano(d0)) * (flip ? -1n : 1n);
    const diffNanoRounded = roundToIncrementBI(diffNano, nanoIn[smallestUnit] * roundingIncrement, roundingFunc);
    return nanoToDuration(diffNanoRounded, largestUnit);
  }
  let durationFields = computeExactDuration(spannedDuration, smallestUnit, d0, d1);
  const unitName = durationUnitNames[smallestUnit];
  function doRound() {
    const orig = durationFields[unitName];
    durationFields[unitName] = roundToIncrement(orig, roundingIncrement, roundingFunc);
  }
  if (roundingFunc === Math.round) {
    doRound();
  }
  if (flip) {
    durationFields = negateDuration(durationFields);
  }
  if (roundingFunc !== Math.round) {
    doRound();
  }
  if (smallestUnit > NANOSECOND) {
    if (flip) {
      durationFields = negateDuration(spanDurationFrom(negateDuration(durationFields), largestUnit, d0, calendar));
    } else {
      durationFields = spanDurationFrom(durationFields, largestUnit, d0, calendar);
    }
  }
  return durationFields;
}

// src/public/duration.ts
var [getFields, setFields] = createWeakMap();
var Duration = class extends AbstractNoValueObj {
  constructor(years = 0, months = 0, weeks = 0, days = 0, hours = 0, minutes = 0, seconds = 0, milliseconds = 0, microseconds = 0, nanoseconds = 0) {
    super();
    const numberFields = processDurationFields({
      years,
      months,
      weeks,
      days,
      hours,
      minutes,
      seconds,
      milliseconds,
      microseconds,
      nanoseconds
    });
    setFields(this, refineDurationNumbers(numberFields));
  }
  static from(arg) {
    return createDuration(typeof arg === "object" ? processDurationFields(arg) : parseDuration(arg));
  }
  static compare(a, b, options) {
    return compareDurations(ensureObj(Duration, a), ensureObj(Duration, b), extractRelativeTo(ensureOptionsObj(options).relativeTo));
  }
  get years() {
    return getFields(this).years;
  }
  get months() {
    return getFields(this).months;
  }
  get weeks() {
    return getFields(this).weeks;
  }
  get days() {
    return getFields(this).days;
  }
  get hours() {
    return getFields(this).hours;
  }
  get minutes() {
    return getFields(this).minutes;
  }
  get seconds() {
    return getFields(this).seconds;
  }
  get milliseconds() {
    return getFields(this).milliseconds;
  }
  get microseconds() {
    return getFields(this).microseconds;
  }
  get nanoseconds() {
    return getFields(this).nanoseconds;
  }
  get sign() {
    return getFields(this).sign;
  }
  get blank() {
    return !this.sign;
  }
  with(fields) {
    return createDuration({
      ...getFields(this),
      ...processDurationFields(fields)
    });
  }
  negated() {
    return createDuration(negateDuration(getFields(this)));
  }
  abs() {
    return createDuration(absDuration(getFields(this)));
  }
  add(other, options) {
    return addDurations(this, ensureObj(Duration, other), options);
  }
  subtract(other, options) {
    return addDurations(this, negateDuration(ensureObj(Duration, other)), options);
  }
  round(options) {
    const optionsObj = typeof options === "string" ? { smallestUnit: options } : options;
    if (!isObjectLike(optionsObj)) {
      throw new TypeError("Must specify options");
    } else if (optionsObj.largestUnit === void 0 && optionsObj.smallestUnit === void 0) {
      throw new RangeError("Must specify either largestUnit or smallestUnit");
    }
    const defaultLargestUnit = computeLargestDurationUnit(this);
    const diffConfig = parseDiffOptions(optionsObj, defaultLargestUnit, NANOSECOND, NANOSECOND, YEAR, true);
    const relativeTo = extractRelativeTo(optionsObj.relativeTo);
    return createDuration(roundDuration(this, diffConfig, relativeTo, relativeTo ? relativeTo.calendar : void 0));
  }
  total(options) {
    const totalConfig = parseTotalConfig(options);
    const relativeTo = extractRelativeTo(totalConfig.relativeTo);
    return computeTotalUnits(this, totalConfig.unit, relativeTo, relativeTo ? relativeTo.calendar : void 0);
  }
  toString(options) {
    const formatConfig = parseTimeToStringOptions(options, SECOND);
    return formatDurationISO(getFields(this), formatConfig);
  }
  toLocaleString(_locales, _options) {
    return this.toString();
  }
};
attachStringTag(Duration, "Duration");
function createDuration(fields) {
  return new Duration(fields.years, fields.months, fields.weeks, fields.days, fields.hours, fields.minutes, fields.seconds, fields.milliseconds, fields.microseconds, fields.nanoseconds);
}
function addDurations(d0, d1, options) {
  const relativeTo = extractRelativeTo(ensureOptionsObj(options).relativeTo);
  return createDuration(addDurationFields(d0, d1, relativeTo, relativeTo ? relativeTo.calendar : void 0));
}

// src/public/plainDateTime.ts
var PlainDateTime = class extends AbstractISOObj {
  constructor(isoYear, isoMonth, isoDay, isoHour = 0, isoMinute = 0, isoSecond = 0, isoMillisecond = 0, isoMicrosecond = 0, isoNanosecond = 0, calendarArg = createDefaultCalendar()) {
    const constrained = constrainDateTimeISO({
      isoYear,
      isoMonth,
      isoDay,
      isoHour,
      isoMinute,
      isoSecond,
      isoMillisecond,
      isoMicrosecond,
      isoNanosecond
    }, OVERFLOW_REJECT);
    const calendar = ensureObj(Calendar, calendarArg);
    validateDateTime(constrained, calendar.id);
    super({
      ...constrained,
      calendar
    });
  }
  static from(arg, options) {
    const overflowHandling = parseOverflowOption(options);
    return createDateTime(arg instanceof PlainDateTime ? arg.getISOFields() : typeof arg === "object" ? processDateTimeFromFields(arg, overflowHandling, options) : refineBaseObj(parseDateTime(String(arg))));
  }
  static compare(a, b) {
    return compareDateTimes(ensureObj(PlainDateTime, a), ensureObj(PlainDateTime, b));
  }
  with(fields, options) {
    const overflowHandling = parseOverflowOption(options);
    return createDateTime(processDateTimeWithFields(this, fields, overflowHandling, options));
  }
  withPlainDate(dateArg) {
    const date = ensureObj(PlainDate, dateArg);
    return createDateTime({
      ...this.getISOFields(),
      ...date.getISOFields(),
      calendar: getStrangerCalendar(this, date)
    });
  }
  withPlainTime(timeArg) {
    return createDateTime({
      ...this.getISOFields(),
      ...ensureLooseTime(timeArg).getISOFields()
    });
  }
  withCalendar(calendarArg) {
    return createDateTime({
      ...this.getISOFields(),
      calendar: ensureObj(Calendar, calendarArg)
    });
  }
  add(durationArg, options) {
    return translatePlainDateTime(this, ensureObj(Duration, durationArg), options);
  }
  subtract(durationArg, options) {
    return translatePlainDateTime(this, negateDuration(ensureObj(Duration, durationArg)), options);
  }
  until(other, options) {
    return diffPlainDateTimes(this, ensureObj(PlainDateTime, other), false, options);
  }
  since(other, options) {
    return diffPlainDateTimes(this, ensureObj(PlainDateTime, other), true, options);
  }
  round(options) {
    const roundingConfig = parseRoundingOptions(options, void 0, NANOSECOND, DAY);
    return createDateTime({
      ...roundDateTime(this.getISOFields(), roundingConfig),
      calendar: this.calendar
    });
  }
  equals(other) {
    return !compareDateTimes(this, ensureObj(PlainDateTime, other));
  }
  toString(options) {
    const formatConfig = parseTimeToStringOptions(options);
    const calendarDisplay = parseCalendarDisplayOption(options);
    const isoFields = roundDateTime(this.getISOFields(), formatConfig);
    return formatDateTimeISO(isoFields, formatConfig) + formatCalendarID(this.calendar.toString(), calendarDisplay);
  }
  toZonedDateTime(timeZoneArg, options) {
    const timeZone = ensureObj(TimeZone, timeZoneArg);
    const instant = timeZone.getInstantFor(this, options);
    return new ZonedDateTime2(instant.epochNanoseconds, timeZone, this.calendar);
  }
  toPlainYearMonth() {
    return createYearMonth(this.getISOFields());
  }
  toPlainMonthDay() {
    return this.calendar.monthDayFromFields(this);
  }
  toPlainDate() {
    return createDate(this.getISOFields());
  }
  toPlainTime() {
    return createTime(this.getISOFields());
  }
};
attachStringTag(PlainDateTime, "PlainDateTime");
mixinISOFields(PlainDateTime, timeUnitNames);
mixinCalendarFields(PlainDateTime, dateCalendarFields);
mixinLocaleStringMethods(PlainDateTime, createPlainFormatFactoryFactory({
  year: "numeric",
  month: "numeric",
  day: "numeric",
  weekday: void 0,
  hour: "numeric",
  minute: "2-digit",
  second: "2-digit"
}, {}));
function createDateTime(isoFields) {
  return new PlainDateTime(isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay, isoFields.isoHour, isoFields.isoMinute, isoFields.isoSecond, isoFields.isoMillisecond, isoFields.isoMicrosecond, isoFields.isoNanosecond, isoFields.calendar);
}
function translatePlainDateTime(pdt0, dur, options) {
  const isoFields = translateDateTime(pdt0.getISOFields(), dur, options);
  return createDateTime({
    ...isoFields,
    calendar: pdt0.calendar
  });
}
function diffPlainDateTimes(pdt0, pdt1, flip, options) {
  const diffConfig = parseDiffOptions(options, DAY, NANOSECOND, NANOSECOND, YEAR);
  return createDuration(diffDateTimes(pdt0, pdt1, getCommonCalendar(pdt0, pdt1), flip, diffConfig));
}

// src/public/plainMonthDay.ts
var PlainMonthDay = class extends AbstractISOObj {
  constructor(isoMonth, isoDay, calendar = createDefaultCalendar(), referenceISOYear = isoEpochLeapYear) {
    super({
      ...constrainDateISO({ isoYear: referenceISOYear, isoMonth, isoDay }, OVERFLOW_REJECT),
      calendar
    });
  }
  static from(arg, options) {
    parseOverflowOption(options);
    if (arg instanceof PlainMonthDay) {
      return createMonthDay(arg.getISOFields());
    }
    if (typeof arg === "object") {
      return processMonthDayFromFields(arg, options);
    }
    const parsed = parseMonthDay(String(arg));
    if (parsed.calendar === void 0) {
      parsed.isoYear = isoEpochLeapYear;
    }
    return createMonthDay(refineBaseObj(parsed));
  }
  with(fields, options) {
    return processMonthDayWithFields(this, fields, options);
  }
  equals(other) {
    return !compareDateTimes(this, ensureObj(PlainMonthDay, other));
  }
  toString(options) {
    const fields = this.getISOFields();
    const calendarID = fields.calendar.toString();
    const calendarDisplay = parseCalendarDisplayOption(options);
    return (calendarID === isoCalendarID ? formatMonthDayISO(fields) : formatDateISO(fields)) + formatCalendarID(calendarID, calendarDisplay);
  }
  toPlainDate(fields) {
    return this.calendar.dateFromFields({
      year: fields.year,
      monthCode: this.monthCode,
      day: this.day
    }, {
      overflow: "reject"
    });
  }
};
attachStringTag(PlainMonthDay, "PlainMonthDay");
mixinISOFields(PlainMonthDay);
mixinCalendarFields(PlainMonthDay, monthDayCalendarFields);
mixinLocaleStringMethods(PlainMonthDay, createPlainFormatFactoryFactory({
  month: "numeric",
  day: "numeric"
}, {
  weekday: void 0,
  year: void 0,
  hour: void 0,
  minute: void 0,
  second: void 0
}, true));
function createMonthDay(isoFields) {
  return new PlainMonthDay(isoFields.isoMonth, isoFields.isoDay, isoFields.calendar, isoFields.isoYear);
}

// src/dateUtils/calendar.ts
function isDateISOInstance(arg) {
  return arg instanceof PlainDate || arg instanceof PlainDateTime || arg instanceof ZonedDateTime2 || arg instanceof PlainYearMonth || arg instanceof PlainMonthDay;
}
function queryDateFields(arg, calendar, disallowMonthDay) {
  let date;
  if (arg instanceof PlainDate) {
    date = arg;
  } else if (isDateISOInstance(arg)) {
    if (disallowMonthDay && arg instanceof PlainMonthDay) {
      throw new TypeError("PlainMonthDay not allowed");
    }
    date = createDate(arg.getISOFields());
  } else {
    date = PlainDate.from(arg);
  }
  ensureCalendarsEqual(date.calendar, calendar);
  return date;
}
function queryDateISOFields(dateLike, calendarImpl, options) {
  if (isDateISOInstance(dateLike)) {
    return dateLike.getISOFields();
  }
  let { era, eraYear, year, month, monthCode, day } = dateLike;
  const yearFromEra = eraYear !== void 0 && era !== void 0 ? convertEraYear(calendarImpl.id, eraYear, era) : void 0;
  if (year === void 0) {
    if (yearFromEra !== void 0) {
      year = yearFromEra;
    } else {
      throw new TypeError("Must specify either a year or an era & eraYear");
    }
  } else {
    if (yearFromEra !== void 0) {
      if (yearFromEra !== year) {
        throw new RangeError("year and era/eraYear must match");
      }
    }
  }
  if (day === void 0) {
    throw new TypeError("Must specify day");
  }
  const overflow = parseOverflowOption(options);
  if (monthCode !== void 0) {
    const [tryMonth, unusedLeap] = calendarImpl.convertMonthCode(monthCode, year);
    if (month !== void 0 && month !== tryMonth) {
      throw new RangeError("Month doesnt match with monthCode");
    }
    month = tryMonth;
    if (unusedLeap) {
      if (overflow === OVERFLOW_REJECT) {
        throw new RangeError("Month code out of range");
      }
      day = calendarImpl.daysInMonth(year, month);
    }
  } else if (month === void 0) {
    throw new TypeError("Must specify either a month or monthCode");
  }
  [year, month, day] = constrainDateFields(year, month, day, calendarImpl, overflow);
  return epochMilliToISOFields(calendarImpl.epochMilliseconds(year, month, day));
}
function getExistingDateISOFields(dateArg, disallowMonthDay) {
  if (isDateISOInstance(dateArg)) {
    if (disallowMonthDay && dateArg instanceof PlainMonthDay) {
      throw new TypeError("PlainMonthDay not allowed");
    }
    return dateArg.getISOFields();
  } else {
    return PlainDate.from(dateArg).getISOFields();
  }
}
function computeDaysInYear(calendarImpl, year) {
  return diffDaysMilli(calendarImpl.epochMilliseconds(year, 1, 1), calendarImpl.epochMilliseconds(year + 1, 1, 1));
}
function computeDayOfYear(calendarImpl, year, month, day) {
  return diffDaysMilli(calendarImpl.epochMilliseconds(year, 1, 1), calendarImpl.epochMilliseconds(year, month, day)) + 1;
}

// src/calendarImpl/intlCalendarImpl.ts
var calLeapMonths = {
  hebrew: 6,
  chinese: 0,
  dangi: 0
};
var IntlCalendarImpl = class extends CalendarImpl {
  constructor(id) {
    const format = buildFormat(id);
    if (!isRelatedCalendar(id, format.resolvedOptions().calendar)) {
      throw new RangeError("Invalid calendar: " + id);
    }
    super(id);
    this.format = format;
    this.yearCorrection = this.computeFieldsDumb(0).year - isoEpochOriginYear;
    this.monthCacheByYear = {};
  }
  epochMilliseconds(year, month, day) {
    const epochMillis = this.queryMonthCache(year)[0];
    const marker = epochMillis[month - 1];
    return addDaysMilli(marker, day - 1);
  }
  daysInMonth(year, month) {
    const epochMillis = this.queryMonthCache(year)[0];
    const startMarker = epochMillis[month - 1];
    if (month >= epochMillis.length) {
      year++;
      month = 0;
    }
    const endMarker = this.queryMonthCache(year)[0][month];
    return diffDaysMilli(startMarker, endMarker);
  }
  monthsInYear(year) {
    const epochMillis = this.queryMonthCache(year)[0];
    return epochMillis.length;
  }
  monthCode(month, year) {
    const leapMonth = this.queryLeapMonthByYear(year);
    if (!leapMonth || month < leapMonth) {
      return super.monthCode(month, year);
    }
    return super.monthCode(month - 1, year) + (month === leapMonth ? "L" : "");
  }
  convertMonthCode(monthCode, year) {
    const leapMonth = this.queryLeapMonthByYear(year);
    let monthCodeIsLeap = /L$/.test(monthCode);
    let monthCodeInt = parseInt(monthCode.substr(1));
    let unusedLeap = false;
    if (monthCodeIsLeap) {
      const presetLeapMonth = calLeapMonths[this.id];
      if (presetLeapMonth === void 0) {
        throw new RangeError("Calendar system doesnt support leap months");
      }
      if (presetLeapMonth) {
        if (monthCodeInt !== presetLeapMonth - 1) {
          throw new RangeError("Invalid leap-month month code");
        }
      } else {
        if (monthCodeInt <= 1 || monthCodeInt >= 12) {
          throw new RangeError("Invalid leap-month month code");
        }
      }
    }
    if (monthCodeIsLeap && !(leapMonth && monthCodeInt === leapMonth - 1)) {
      unusedLeap = true;
      monthCodeIsLeap = false;
    }
    if (monthCodeIsLeap || leapMonth && monthCodeInt >= leapMonth) {
      monthCodeInt++;
    }
    return [monthCodeInt, unusedLeap];
  }
  inLeapYear(year) {
    const days = computeDaysInYear(this, year);
    return days > computeDaysInYear(this, year - 1) && days > computeDaysInYear(this, year + 1);
  }
  guessYearForMonthDay(monthCode, day) {
    let year = isoEpochOriginYear + this.yearCorrection;
    const maxYear = year + 100;
    for (; year < maxYear; year++) {
      const [month, unusedLeap] = this.convertMonthCode(monthCode, year);
      if (!unusedLeap && month <= this.monthsInYear(year) && day <= this.daysInMonth(year, month)) {
        return year;
      }
    }
    throw new Error("Could not guess year");
  }
  normalizeISOYearForMonthDay(isoYear) {
    return isoYear;
  }
  computeFields(epochMilli) {
    const dumbFields = this.computeFieldsDumb(epochMilli);
    const monthStrToNum = this.queryMonthCache(dumbFields.year)[2];
    return {
      ...dumbFields,
      month: monthStrToNum[dumbFields.month]
    };
  }
  computeFieldsDumb(epochMilli) {
    const partHash = hashIntlFormatParts(this.format, epochMilli);
    let era;
    let eraYear;
    let year = parseInt(partHash.relatedYear || partHash.year);
    if (partHash.era && hasEras(this.id)) {
      era = normalizeShortEra(partHash.era);
      eraYear = year;
      year = convertEraYear(this.id, eraYear, era, true);
    }
    return {
      era,
      eraYear,
      year,
      month: partHash.month,
      day: parseInt(partHash.day)
    };
  }
  queryLeapMonthByYear(year) {
    const currentCache = this.queryMonthCache(year);
    const prevCache = this.queryMonthCache(year - 1);
    const nextCache = this.queryMonthCache(year + 1);
    if (currentCache[0].length > prevCache[0].length && currentCache[0].length > nextCache[0].length) {
      const currentMonthStrs = currentCache[1];
      const prevMonthStrs = prevCache[1];
      for (let i = 0; i < prevMonthStrs.length; i++) {
        if (prevMonthStrs[i] !== currentMonthStrs[i]) {
          return i + 1;
        }
      }
    }
    return void 0;
  }
  queryMonthCache(year) {
    const { monthCacheByYear } = this;
    return monthCacheByYear[year] || (monthCacheByYear[year] = this.buildMonthCache(year));
  }
  buildMonthCache(year) {
    const epochMillis = [];
    const monthStrs = [];
    const monthStrToNum = {};
    let epochMilli = isoToEpochMilli(this.guessISOYear(year), 1, 1);
    epochMilli = addDaysMilli(epochMilli, 400);
    while (true) {
      const fields = this.computeFieldsDumb(epochMilli);
      if (fields.year < year) {
        break;
      }
      epochMilli = addDaysMilli(epochMilli, 1 - fields.day);
      if (fields.year === year) {
        epochMillis.unshift(epochMilli);
        monthStrs.unshift(fields.month);
      }
      epochMilli = addDaysMilli(epochMilli, -1);
    }
    for (let i = 0; i < monthStrs.length; i++) {
      monthStrToNum[monthStrs[i]] = i + 1;
    }
    return [epochMillis, monthStrs, monthStrToNum];
  }
  guessISOYear(year) {
    return year - this.yearCorrection;
  }
};
function buildFormat(calendarID) {
  return new OrigDateTimeFormat("en-US", {
    calendar: calendarID,
    era: "short",
    year: "numeric",
    month: "short",
    day: "numeric",
    timeZone: "UTC"
  });
}
function isRelatedCalendar(specificCalendarID, relatedCalendarID) {
  return getCalendarIDBase(specificCalendarID) === getCalendarIDBase(relatedCalendarID);
}

// src/calendarImpl/islamicCalendarImpl.ts
var IslamicCalendarImpl = class extends IntlCalendarImpl {
  guessISOYear(year) {
    return Math.ceil(year * 32 / 33 + 622);
  }
};

// src/calendarImpl/japaneseCalendarImpl.ts
var primaryEraMilli = isoToEpochMilli(1868, 9, 8);
var JapaneseCalendarImpl = class extends GregoryCalendarImpl {
  constructor() {
    super(...arguments);
    this.format = buildFormat("japanese");
  }
  computeFields(epochMilli) {
    const fields = super.computeFields(epochMilli);
    if (epochMilli >= primaryEraMilli) {
      const partHash = hashIntlFormatParts(this.format, epochMilli);
      fields.era = normalizeShortEra(partHash.era);
      fields.eraYear = parseInt(partHash.relatedYear || partHash.year);
    }
    return fields;
  }
};

// src/calendarImpl/calendarImplQuery.ts
var implClasses = {
  gregory: GregoryCalendarImpl,
  japanese: JapaneseCalendarImpl,
  islamic: IslamicCalendarImpl
};
var implCache2 = {
  [isoCalendarID]: isoCalendarImpl
};
function queryCalendarImpl(id) {
  id = String(id);
  const key = id.toLocaleLowerCase();
  return implCache2[key] || (implCache2[key] = new (implClasses[getCalendarIDBase(key)] || IntlCalendarImpl)(id));
}

// src/calendarImpl/bugs.ts
var good1582 = isoToEpochMilli(1582, 10, 15);
var goodIslamic = isoToEpochMilli(622, 7, 18);
var goodEpochMillis = {
  buddhist: good1582,
  japanese: good1582,
  roc: good1582,
  islamic: goodIslamic,
  "islamic-rgsa": goodIslamic,
  indian: 0
};
var hasBugByID = {};
function checkEpochNanoBuggy(epochNano, calendarID) {
  return checkEpochMilliBuggy(Number(epochNano / nanoInMilliBI), calendarID);
}
function checkEpochMilliBuggy(epochMilli, calendarID) {
  if (isEpochMilliBuggy(epochMilli, calendarID)) {
    throw new RangeError("Invalid timestamp for calendar");
  }
}
function isEpochMilliBuggy(epochMilli, calendarID) {
  return hasEpochMilliBug(calendarID) && epochMilli < goodEpochMillis[calendarID];
}
function hasEpochMilliBug(calendarID) {
  let hasBug = hasBugByID[calendarID];
  if (hasBug === void 0) {
    const goodEpochMilli = goodEpochMillis[calendarID];
    if (goodEpochMilli === void 0) {
      hasBug = false;
    } else {
      let impl = queryCalendarImpl(calendarID);
      if (!(impl instanceof IntlCalendarImpl)) {
        impl = new IntlCalendarImpl(calendarID);
      }
      const badEpochMilli = goodEpochMilli - milliInDay;
      const fields = impl.computeFields(badEpochMilli);
      hasBug = badEpochMilli !== impl.epochMilliseconds(fields.year, fields.month, fields.day);
    }
    hasBugByID[calendarID] = hasBug;
  }
  return hasBug;
}

// src/dateUtils/week.ts
function computeWeekOfISOYear(isoYear, isoMonth, isoDay, firstDay, minimalDays) {
  const weekOffset = computeFirstWeekOffset(isoYear, firstDay, minimalDays);
  const week = Math.floor((computeDayOfYear(isoCalendarImpl, isoYear, isoMonth, isoDay) - weekOffset - 1) / 7) + 1;
  if (week < 1) {
    return week + computeWeeksInISOYear(isoYear - 1, firstDay, minimalDays);
  }
  const weeksYear = computeWeeksInISOYear(isoYear, firstDay, minimalDays);
  if (week > weeksYear) {
    return week - weeksYear;
  }
  return week;
}
function computeFirstWeekOffset(isoYear, firstDay, minimalDays) {
  const firstWeekDay = 7 + firstDay - minimalDays;
  const localWeek = positiveModulo(computeISODayOfWeek(isoYear, 1, firstWeekDay) - firstDay, 7);
  return -localWeek + firstWeekDay - 1;
}
function computeWeeksInISOYear(isoYear, firstDay, minimalDays) {
  const weekOffset = computeFirstWeekOffset(isoYear, firstDay, minimalDays);
  const weekOffsetNext = computeFirstWeekOffset(isoYear + 1, firstDay, minimalDays);
  return (computeDaysInYear(isoCalendarImpl, isoYear) - weekOffset + weekOffsetNext) / 7;
}

// src/public/calendar.ts
var [getImpl2, setImpl2] = createWeakMap();
var Calendar = class extends AbstractObj {
  constructor(id) {
    super();
    if (id === "islamicc") {
      id = "islamic-civil";
    }
    setImpl2(this, queryCalendarImpl(id));
  }
  static from(arg) {
    if (typeof arg === "object" && arg) {
      if (isCalendarArgBag(arg)) {
        return parseCalendarArgFromBag(arg.calendar);
      } else {
        return arg;
      }
    }
    const parsed = tryParseDateTime(String(arg), false, true);
    return new Calendar(parsed ? parsed.calendar || isoCalendarID : arg);
  }
  get id() {
    return this.toString();
  }
  era(arg) {
    const isoFields = getExistingDateISOFields(arg, true);
    return isoToEpochNanoSafe(getImpl2(this), isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay).era;
  }
  eraYear(arg) {
    const isoFields = getExistingDateISOFields(arg, true);
    return isoToEpochNanoSafe(getImpl2(this), isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay).eraYear;
  }
  year(arg) {
    const isoFields = getExistingDateISOFields(arg, true);
    return isoToEpochNanoSafe(getImpl2(this), isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay).year;
  }
  month(arg) {
    const isoFields = getExistingDateISOFields(arg, true);
    return isoToEpochNanoSafe(getImpl2(this), isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay).month;
  }
  monthCode(arg) {
    const fields = queryDateFields(arg, this);
    return getImpl2(this).monthCode(fields.month, fields.year);
  }
  day(arg) {
    const isoFields = getExistingDateISOFields(arg);
    return isoToEpochNanoSafe(getImpl2(this), isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay).day;
  }
  dayOfWeek(arg) {
    const isoFields = getExistingDateISOFields(arg, true);
    return computeISODayOfWeek(isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay);
  }
  dayOfYear(arg) {
    const fields = queryDateFields(arg, this, true);
    return computeDayOfYear(getImpl2(this), fields.year, fields.month, fields.day);
  }
  weekOfYear(arg) {
    const isoFields = getExistingDateISOFields(arg, true);
    return computeWeekOfISOYear(isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay, 1, 4);
  }
  daysInWeek(arg) {
    getExistingDateISOFields(arg, true);
    return 7;
  }
  daysInMonth(arg) {
    const fields = queryDateFields(arg, this, true);
    return getImpl2(this).daysInMonth(fields.year, fields.month);
  }
  daysInYear(arg) {
    const fields = queryDateFields(arg, this, true);
    return computeDaysInYear(getImpl2(this), fields.year);
  }
  monthsInYear(arg) {
    const calFields = queryDateFields(arg, this, true);
    return getImpl2(this).monthsInYear(calFields.year);
  }
  inLeapYear(arg) {
    return getImpl2(this).inLeapYear(this.year(arg));
  }
  dateFromFields(fields, options) {
    const refinedFields = refineFields(fields, dateFieldMap);
    const isoFields = queryDateISOFields(refinedFields, getImpl2(this), options);
    return new PlainDate(isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay, this);
  }
  yearMonthFromFields(fields, options) {
    const refinedFields = refineFields(fields, yearMonthFieldMap);
    const isoFields = queryDateISOFields({ ...refinedFields, day: 1 }, getImpl2(this), options);
    return new PlainYearMonth(isoFields.isoYear, isoFields.isoMonth, this, isoFields.isoDay);
  }
  monthDayFromFields(fields, options) {
    const impl = getImpl2(this);
    const refinedFields = refineFields(fields, monthDayFieldMap);
    let { era, eraYear, year, month, monthCode, day } = refinedFields;
    if (day === void 0) {
      throw new TypeError("required property 'day' missing or undefined");
    }
    if (monthCode !== void 0) {
      year = isoEpochLeapYear;
    } else if (era !== void 0 && eraYear !== void 0) {
      year = convertEraYear(impl.id, eraYear, era);
    }
    if (year === void 0) {
      if (monthCode !== void 0) {
        year = impl.guessYearForMonthDay(monthCode, day);
      } else {
        throw new TypeError("either year or monthCode required with month");
      }
    }
    const isoFields = queryDateISOFields({ year, month, monthCode, day }, impl, options);
    return new PlainMonthDay(isoFields.isoMonth, isoFields.isoDay, this, impl.normalizeISOYearForMonthDay(isoFields.isoYear));
  }
  dateAdd(dateArg, durationArg, options) {
    const impl = getImpl2(this);
    const date = ensureObj(PlainDate, dateArg, options);
    const duration = ensureObj(Duration, durationArg);
    const overflowHandling = parseOverflowOption(options);
    const isoFields = translateDate(date, duration, impl, overflowHandling);
    return new PlainDate(isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay, this);
  }
  dateUntil(dateArg0, dateArg1, options) {
    const impl = getImpl2(this);
    const d0 = ensureObj(PlainDate, dateArg0);
    const d1 = ensureObj(PlainDate, dateArg1);
    const largestUnit = parseUnit(ensureOptionsObj(options).largestUnit, DAY, DAY, YEAR);
    ensureCalendarsEqual(this, getCommonCalendar(d0, d1));
    return createDuration(diffDateFields(d0, d1, impl, largestUnit));
  }
  fields(inFields) {
    return inFields.slice();
  }
  mergeFields(baseFields, additionalFields) {
    return mergeCalFields(baseFields, additionalFields);
  }
  toString() {
    return getImpl2(this).id;
  }
};
attachStringTag(Calendar, "Calendar");
function createDefaultCalendar() {
  return new Calendar(isoCalendarID);
}
function mergeCalFields(baseFields, additionalFields) {
  const merged = { ...baseFields, ...additionalFields };
  if (baseFields.year !== void 0) {
    delete merged.era;
    delete merged.eraYear;
    delete merged.year;
    let anyAdditionalYear = false;
    if (additionalFields.era !== void 0 || additionalFields.eraYear !== void 0) {
      merged.era = additionalFields.era;
      merged.eraYear = additionalFields.eraYear;
      anyAdditionalYear = true;
    }
    if (additionalFields.year !== void 0) {
      merged.year = additionalFields.year;
      anyAdditionalYear = true;
    }
    if (!anyAdditionalYear) {
      merged.year = baseFields.year;
    }
  }
  if (baseFields.monthCode !== void 0) {
    delete merged.monthCode;
    delete merged.month;
    let anyAdditionalMonth = false;
    if (additionalFields.month !== void 0) {
      merged.month = additionalFields.month;
      anyAdditionalMonth = true;
    }
    if (additionalFields.monthCode !== void 0) {
      merged.monthCode = additionalFields.monthCode;
      anyAdditionalMonth = true;
    }
    if (!anyAdditionalMonth) {
      merged.monthCode = baseFields.monthCode;
    }
  }
  if (baseFields.day !== void 0) {
    merged.day = additionalFields.day ?? baseFields.day;
  }
  return merged;
}
function isoToEpochNanoSafe(calendarImpl, isoYear, isoMonth, isoDay) {
  const epochMilli = isoToEpochMilli(isoYear, isoMonth, isoDay);
  checkEpochMilliBuggy(epochMilli, calendarImpl.id);
  return calendarImpl.computeFields(epochMilli);
}

// src/argParse/calendar.ts
function isCalendarArgBag(arg) {
  return arg.calendar;
}
function parseCalendarArgFromBag(arg) {
  if (typeof arg === "object" && arg) {
    if (typeof arg.id === "string") {
      return arg;
    } else {
      throw new RangeError("Invalid calendar");
    }
  }
  return new Calendar(String(arg));
}
function extractCalendar(input) {
  if (input.calendar === void 0) {
    return createDefaultCalendar();
  }
  return ensureObj(Calendar, input.calendar);
}
function getCommonCalendar(obj0, obj1) {
  const { calendar } = obj0;
  ensureCalendarsEqual(calendar, obj1.calendar);
  return calendar;
}
function getStrangerCalendar(obj0, obj1) {
  const calendar0 = obj0.calendar;
  const calendar1 = obj1.calendar;
  if (calendar0.id === isoCalendarID) {
    return calendar1;
  }
  if (calendar1.id === isoCalendarID) {
    return calendar0;
  }
  if (calendar0.id !== calendar1.id) {
    throw new RangeError("Non-ISO calendars incompatible");
  }
  return calendar0;
}
function ensureCalendarsEqual(calendar0, calendar1) {
  if (calendar0.id !== calendar1.id) {
    throw new RangeError("Calendars must match");
  }
}

// src/public/plainDate.ts
var PlainDate = class extends AbstractISOObj {
  constructor(isoYear, isoMonth, isoDay, calendarArg = createDefaultCalendar()) {
    const constrained = constrainDateISO({ isoYear, isoMonth, isoDay }, OVERFLOW_REJECT);
    const calendar = ensureObj(Calendar, calendarArg);
    validateDate(constrained, calendar.id);
    super({
      ...constrained,
      calendar
    });
  }
  static from(arg, options) {
    parseOverflowOption(options);
    if (arg instanceof PlainDate) {
      return createDate(arg.getISOFields());
    }
    if (typeof arg === "object") {
      return processDateFromFields(arg, options);
    }
    return createDate(refineBaseObj(parseDateTime(String(arg))));
  }
  static compare(a, b) {
    return compareDateTimes(ensureObj(PlainDate, a), ensureObj(PlainDate, b));
  }
  with(fields, options) {
    return processDateWithFields(this, fields, options);
  }
  withCalendar(calendarArg) {
    const isoFields = this.getISOFields();
    return new PlainDate(isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay, calendarArg);
  }
  add(durationArg, options) {
    return this.calendar.dateAdd(this, durationArg, options);
  }
  subtract(durationArg, options) {
    return this.calendar.dateAdd(this, ensureObj(Duration, durationArg).negated(), options);
  }
  until(other, options) {
    return diffPlainDates(this, ensureObj(PlainDate, other), false, options);
  }
  since(other, options) {
    return diffPlainDates(this, ensureObj(PlainDate, other), true, options);
  }
  equals(other) {
    return !compareDateTimes(this, ensureObj(PlainDate, other));
  }
  toString(options) {
    const calendarDisplay = parseCalendarDisplayOption(options);
    const fields = this.getISOFields();
    return formatDateISO(fields) + formatCalendarID(fields.calendar.toString(), calendarDisplay);
  }
  toZonedDateTime(options) {
    const refinedOptions = processToZonedDateTimeOptions(options);
    const timeZone = ensureObj(TimeZone, refinedOptions.timeZone);
    const plainTime = refinedOptions.plainTime === void 0 ? void 0 : ensureObj(PlainTime, refinedOptions.plainTime);
    return createZonedDateTimeFromFields({
      ...this.getISOFields(),
      ...plainTime ? plainTime.getISOFields() : zeroISOTimeFields,
      timeZone
    });
  }
  toPlainDateTime(timeArg) {
    return createDateTime({
      ...this.getISOFields(),
      ...ensureLooseTime(timeArg).getISOFields()
    });
  }
  toPlainYearMonth() {
    return createYearMonth(this.getISOFields());
  }
  toPlainMonthDay() {
    return this.calendar.monthDayFromFields(this);
  }
};
attachStringTag(PlainDate, "PlainDate");
mixinISOFields(PlainDate);
mixinCalendarFields(PlainDate, dateCalendarFields);
mixinLocaleStringMethods(PlainDate, createPlainFormatFactoryFactory({
  year: "numeric",
  month: "numeric",
  day: "numeric",
  weekday: void 0
}, {
  hour: void 0,
  minute: void 0,
  second: void 0
}));
function createDate(isoFields) {
  return new PlainDate(isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay, isoFields.calendar);
}
function processToZonedDateTimeOptions(options) {
  let plainTime;
  let timeZone;
  if (typeof options === "string") {
    timeZone = options;
  } else if (typeof options === "object") {
    if (options.id !== void 0) {
      timeZone = options;
    } else {
      timeZone = options.timeZone;
      plainTime = options.plainTime;
    }
    if (timeZone === void 0) {
      throw new TypeError("Invalid timeZone argument");
    }
  } else {
    throw new TypeError("Invalid options/timeZone argument");
  }
  return { plainTime, timeZone };
}
function diffPlainDates(pd0, pd1, flip, options) {
  return createDuration(diffDates(pd0, pd1, getCommonCalendar(pd0, pd1), flip, parseDiffOptions(options, DAY, DAY, DAY, YEAR)));
}

// src/dateUtils/diff.ts
function diffDateTimes(dt0, dt1, calendar, flip, diffConfig) {
  return roundDurationSpan(diffAccurate(dt0, dt1, calendar, diffConfig.largestUnit), dt0, dt1, calendar, flip, diffConfig);
}
function diffDates(d0, d1, calendar, flip, diffConfig) {
  const balancedDuration = calendar.dateUntil(d0, d1, {
    largestUnit: unitNames[diffConfig.largestUnit]
  });
  return roundDurationSpan(balancedDuration, d0, d1, calendar, flip, diffConfig);
}
function diffTimes(t0, t1, diffConfig) {
  const roundedDiff = roundToIncrement(isoTimeToNano(t1) - isoTimeToNano(t0), nanoIn[diffConfig.smallestUnit] * diffConfig.roundingIncrement, diffConfig.roundingFunc);
  return nanoToDuration(BigInt(roundedDiff), diffConfig.largestUnit);
}
function diffEpochNanos(epochNano0, epochNano1, diffConfig) {
  const roundedDiff = roundToIncrementBI(epochNano1 - epochNano0, nanoIn[diffConfig.smallestUnit] * diffConfig.roundingIncrement, diffConfig.roundingFunc);
  return nanoToDuration(roundedDiff, diffConfig.largestUnit);
}
function diffDateFields(d0, d1, calendarImpl, largestUnit) {
  let years = 0;
  let months = 0;
  let weeks = 0;
  let days = 0;
  switch (largestUnit) {
    case YEAR:
      years = wholeYearsUntil(d0, d1, calendarImpl);
      d0 = addYears(d0, years, calendarImpl, OVERFLOW_CONSTRAIN);
    case MONTH:
      months = wholeMonthsUntil(d0, d1, calendarImpl);
      d0 = addMonths(d0, months, calendarImpl, OVERFLOW_CONSTRAIN);
  }
  days = diffDaysMilli(calendarImpl.epochMilliseconds(d0.year, d0.month, d0.day), calendarImpl.epochMilliseconds(d1.year, d1.month, d1.day));
  if (largestUnit === WEEK) {
    weeks = Math.trunc(days / 7);
    days %= 7;
  }
  return signDuration({
    years,
    months,
    weeks,
    days,
    hours: 0,
    minutes: 0,
    seconds: 0,
    milliseconds: 0,
    microseconds: 0,
    nanoseconds: 0
  });
}
function wholeYearsUntil(d0, d1, calendarImpl) {
  const [, newMonth, newDay] = constrainDateFields(d1.year, d0.month, d0.day, calendarImpl, OVERFLOW_CONSTRAIN);
  const generalSign = compareLocalDateFields(d1, d0);
  const monthSign = compareValues(d1.month, newMonth) || compareValues(d1.day, newDay);
  return d1.year - d0.year - (monthSign && generalSign && monthSign !== generalSign ? generalSign : 0);
}
function wholeMonthsUntil(d0, d1, calendarImpl) {
  let monthsToAdd = 0;
  const generalSign = compareLocalDateFields(d1, d0);
  if (generalSign) {
    let { year } = d0;
    while (year !== d1.year) {
      monthsToAdd += calendarImpl.monthsInYear(year) * generalSign;
      year += generalSign;
    }
    const [, newMonth, newDay] = constrainDateFields(d1.year, d0.month, d0.day, calendarImpl, OVERFLOW_CONSTRAIN);
    monthsToAdd += d1.month - newMonth;
    const daySign = compareValues(d1.day, newDay);
    if (daySign && generalSign && daySign !== generalSign) {
      monthsToAdd -= generalSign;
    }
  }
  return monthsToAdd;
}
function diffAccurate(dt0, dt1, calendar, largestUnit) {
  if (!isDateUnit(largestUnit)) {
    return diffTimeScale(dt0, dt1, largestUnit);
  }
  const dateStart = createDate({ ...dt0.getISOFields(), calendar });
  let dateMiddle = createDate({ ...dt1.getISOFields(), calendar });
  let dateTimeMiddle;
  let bigDuration;
  let timeDuration;
  let bigSign;
  let timeSign;
  do {
    bigDuration = calendar.dateUntil(dateStart, dateMiddle, { largestUnit: unitNames[largestUnit] });
    dateTimeMiddle = dt0.add(bigDuration);
    timeDuration = diffTimeScale(dateTimeMiddle, dt1, HOUR);
    bigSign = bigDuration.sign;
    timeSign = timeDuration.sign;
  } while (bigSign && timeSign && bigSign !== timeSign && (dateMiddle = dateMiddle.add({ days: timeSign })));
  return mergeDurations(bigDuration, timeDuration);
}
function diffTimeScale(dt0, dt1, largestUnit) {
  return nanoToDuration(toEpochNano(dt1) - toEpochNano(dt0), largestUnit);
}

// src/public/instant.ts
var [getEpochNano, setEpochNano] = createWeakMap();
var Instant = class extends AbstractNoValueObj {
  constructor(epochNanoseconds) {
    super();
    if (typeof epochNanoseconds === "number") {
      throw new TypeError("Must supply bigint, not number");
    }
    epochNanoseconds = BigInt(epochNanoseconds);
    validateInstant(epochNanoseconds);
    setEpochNano(this, epochNanoseconds);
  }
  static from(arg) {
    if (arg instanceof Instant) {
      return new Instant(arg.epochNanoseconds);
    }
    const fields = parseZonedDateTime(String(arg));
    const offsetNano = fields.offsetNanoseconds;
    if (offsetNano === void 0) {
      throw new RangeError("Must specify an offset");
    }
    return new Instant(isoFieldsToEpochNano(constrainDateTimeISO(fields, OVERFLOW_REJECT)) - BigInt(offsetNano));
  }
  static fromEpochSeconds(epochSeconds) {
    return new Instant(BigInt(epochSeconds) * nanoInSecondBI);
  }
  static fromEpochMilliseconds(epochMilliseconds) {
    return new Instant(BigInt(epochMilliseconds) * nanoInMilliBI);
  }
  static fromEpochMicroseconds(epochMicroseconds) {
    return new Instant(epochMicroseconds * nanoInMicroBI);
  }
  static fromEpochNanoseconds(epochNanoseconds) {
    return new Instant(epochNanoseconds);
  }
  static compare(a, b) {
    return compareEpochObjs(ensureObj(Instant, a), ensureObj(Instant, b));
  }
  get epochNanoseconds() {
    return getEpochNano(this);
  }
  add(durationArg) {
    return new Instant(translateEpochNano(this.epochNanoseconds, ensureObj(Duration, durationArg)));
  }
  subtract(durationArg) {
    return new Instant(translateEpochNano(this.epochNanoseconds, negateDuration(ensureObj(Duration, durationArg))));
  }
  until(other, options) {
    return diffInstants(this, ensureObj(Instant, other), options);
  }
  since(other, options) {
    return diffInstants(ensureObj(Instant, other), this, options);
  }
  round(options) {
    const roundingConfig = parseRoundingOptions(options, void 0, NANOSECOND, HOUR, true);
    return new Instant(roundEpochNano(this.epochNanoseconds, roundingConfig));
  }
  equals(other) {
    return !compareEpochObjs(this, ensureObj(Instant, other));
  }
  toString(options) {
    const timeZoneArg = ensureOptionsObj(options).timeZone;
    const zonedDateTime = this.toZonedDateTimeISO(timeZoneArg ?? "UTC");
    return zonedDateTime.toString({
      ...options,
      offset: timeZoneArg === void 0 ? "never" : "auto",
      timeZoneName: "never"
    }) + (timeZoneArg === void 0 ? "Z" : "");
  }
  toZonedDateTimeISO(timeZoneArg) {
    return new ZonedDateTime2(this.epochNanoseconds, timeZoneArg);
  }
  toZonedDateTime(options) {
    if (!isObjectLike(options)) {
      throw new TypeError("Must specify options");
    } else if (options.calendar === void 0) {
      throw new TypeError("Must specify a calendar");
    } else if (options.timeZone === void 0) {
      throw new TypeError("Must specify a timeZone");
    }
    return new ZonedDateTime2(this.epochNanoseconds, options.timeZone, options.calendar);
  }
};
attachStringTag(Instant, "Instant");
mixinEpochFields(Instant);
mixinLocaleStringMethods(Instant, createZonedFormatFactoryFactory({
  year: "numeric",
  month: "numeric",
  day: "numeric",
  weekday: void 0,
  hour: "numeric",
  minute: "2-digit",
  second: "2-digit"
}, {
  timeZoneName: void 0
}, {}));
function diffInstants(inst0, inst1, options) {
  const diffConfig = parseDiffOptions(options, SECOND, NANOSECOND, NANOSECOND, HOUR);
  return createDuration(diffEpochNanos(inst0.epochNanoseconds, inst1.epochNanoseconds, diffConfig));
}

// src/native/date.ts
function dateToTemporalInstant(date) {
  return Instant.fromEpochMilliseconds(date.valueOf());
}

// src/native/intlExtend.ts
var origLocalesSymbol = Symbol();
var origOptionsSymbol = Symbol();
var factoryMapSymbol = Symbol();
var ExtendedDateTimeFormat = class extends OrigDateTimeFormat {
  constructor(localesArg, options) {
    const normLocales = normalizeAndCopyLocalesArg(localesArg);
    const normOptions = flattenOptions(options || {});
    super(normLocales, normOptions);
    this[origLocalesSymbol] = normLocales;
    this[origOptionsSymbol] = normOptions;
    this[factoryMapSymbol] = /* @__PURE__ */ new Map();
  }
  format(dateArg) {
    const parts = createSingleArgs(this, dateArg);
    if (parts[0] === this) {
      return super.format(dateArg);
    }
    return parts[0].format(parts[1]);
  }
  formatToParts(dateArg) {
    return super.formatToParts.call(...createSingleArgs(this, dateArg));
  }
  formatRange(startArg, endArg) {
    return super.formatRange.call(...createRangeArgs(this, startArg, endArg));
  }
  formatRangeToParts(startArg, endArg) {
    return super.formatRangeToParts.call(...createRangeArgs(this, startArg, endArg));
  }
};
origLocalesSymbol, origOptionsSymbol, factoryMapSymbol;
function createSingleArgs(origDateTimeFormat, dateArg) {
  const buildFormatFactory = extractFormatFactoryFactory(dateArg);
  if (buildFormatFactory) {
    const formatFactory = queryFormatFactoryForType(origDateTimeFormat, buildFormatFactory);
    return [
      formatFactory.buildFormat(dateArg),
      formatFactory.buildEpochMilli(dateArg)
    ];
  }
  return [origDateTimeFormat, dateArg];
}
function createRangeArgs(origDateTimeFormat, startArg, endArg) {
  const buildFormatFactory = extractFormatFactoryFactory(startArg);
  const buildFormatFactoryOther = extractFormatFactoryFactory(endArg);
  if (buildFormatFactory !== buildFormatFactoryOther) {
    throw new TypeError("Mismatch of types");
  }
  if (buildFormatFactory) {
    const formatFactory = queryFormatFactoryForType(origDateTimeFormat, buildFormatFactory);
    return [
      formatFactory.buildFormat(startArg, endArg),
      formatFactory.buildEpochMilli(startArg),
      formatFactory.buildEpochMilli(endArg)
    ];
  }
  return [origDateTimeFormat, startArg, endArg];
}
function queryFormatFactoryForType(origDateTimeFormat, buildFormatFactory) {
  const formatFactoryMap = origDateTimeFormat[factoryMapSymbol];
  let formatFactory = formatFactoryMap.get(buildFormatFactory);
  if (!formatFactory) {
    formatFactory = buildCachedFormatFactory(buildFormatFactory(origDateTimeFormat[origLocalesSymbol], origDateTimeFormat[origOptionsSymbol]));
    formatFactoryMap.set(buildFormatFactory, formatFactory);
  }
  return formatFactory;
}

// src/public/now.ts
var Now = {
  zonedDateTimeISO: getZonedDateTimeISO,
  zonedDateTime: getZonedDateTime,
  plainDateTimeISO: getPlainDateTimeISO,
  plainDateTime: getPlainDateTime,
  plainDateISO: getPlainDateISO,
  plainDate: getPlainDate,
  plainTimeISO: getPlainTimeISO,
  instant: getInstant,
  timeZone: getTimeZone
};
attachStringTag(Now, "Now");
function getZonedDateTimeISO(timeZoneArg) {
  return createZonedDateTimeFromFields(buidZonedFields(isoCalendarID, timeZoneArg));
}
function getZonedDateTime(calendarArg, timeZoneArg) {
  return createZonedDateTimeFromFields(buidZonedFields(calendarArg, timeZoneArg));
}
function getPlainDateTimeISO(timeZoneArg) {
  return createDateTime(buidZonedFields(isoCalendarID, timeZoneArg));
}
function getPlainDateTime(calendarArg, timeZoneArg) {
  return createDateTime(buidZonedFields(calendarArg, timeZoneArg));
}
function getPlainDateISO(timeZoneArg) {
  return createDate(buidZonedFields(isoCalendarID, timeZoneArg));
}
function getPlainDate(calendarArg, timeZoneArg) {
  return createDate(buidZonedFields(calendarArg, timeZoneArg));
}
function getPlainTimeISO(timeZoneArg) {
  return createTime(buidZonedFields(isoCalendarID, timeZoneArg));
}
function getInstant() {
  return new Instant(getEpochNano2());
}
function getTimeZone() {
  return new TimeZone(new OrigDateTimeFormat().resolvedOptions().timeZone);
}
function buidZonedFields(calendarArg, timeZoneArg = getTimeZone()) {
  const timeZone = ensureObj(TimeZone, timeZoneArg);
  return {
    ...buildZonedDateTimeISOFields(getEpochNano2(), timeZone)[0],
    timeZone,
    calendar: ensureObj(Calendar, calendarArg)
  };
}
function getEpochNano2() {
  return BigInt(Date.now()) * nanoInMilliBI;
}
module.exports = __toCommonJS(impl_exports);
